VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMainWnd 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "vbSpec"
   ClientHeight    =   3345
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   4245
   Icon            =   "frmMainWnd.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   223
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   283
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgCommon 
      Left            =   60
      Top             =   2880
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picDisplay 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   2880
      Left            =   180
      ScaleHeight     =   192
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   256
      TabIndex        =   0
      Top             =   240
      Width           =   3840
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000014&
      Index           =   1
      X1              =   0
      X2              =   11880
      Y1              =   1
      Y2              =   1
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      Index           =   0
      X1              =   -4
      X2              =   11880
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu mnuFileMain 
      Caption         =   "&File"
      Begin VB.Menu mnuFile 
         Caption         =   "&Open..."
         Index           =   1
      End
      Begin VB.Menu mnuFile 
         Caption         =   "-"
         Index           =   2
      End
      Begin VB.Menu mnuFile 
         Caption         =   "&Reset Spectrum"
         Index           =   3
      End
      Begin VB.Menu mnuFile 
         Caption         =   "-"
         Index           =   4
      End
      Begin VB.Menu mnuFile 
         Caption         =   "E&xit"
         Index           =   5
      End
   End
   Begin VB.Menu mnuOptionsMain 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptions 
         Caption         =   "&General Settings..."
         Index           =   1
      End
      Begin VB.Menu mnuOptions 
         Caption         =   "&Display..."
         Index           =   2
      End
   End
   Begin VB.Menu mnuHelpMain 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelp 
         Caption         =   "Spectrum &Keyboard..."
         Index           =   1
      End
      Begin VB.Menu mnuHelp 
         Caption         =   "-"
         Index           =   2
      End
      Begin VB.Menu mnuHelp 
         Caption         =   "&About vbSpec..."
         Index           =   3
      End
   End
End
Attribute VB_Name = "frmMainWnd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' /*******************************************************************************
'   frmMainWnd.frm within vbSpec.vbp
'
'   Main application window. Contains the Spectrum display output, processes
'   Keypresses, and contains a timer object used for maintaining the emulator
'   at 50 frames/sec on a fast enough machine, and a common dialog control for
'   use by file open/save operations.
'
'   Author: Chris Cowley <ccowley@grok.co.uk>
'
'   Copyright (C)1999-2000  Grok Developments Ltd.
'   http://www.grok.co.uk/
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' *******************************************************************************/

Option Explicit




Private Sub FileOpenDialog()
    On Error Resume Next
    
    Err.Clear
    dlgCommon.DialogTitle = "Open Snapshot or ROM image"
    dlgCommon.DefaultExt = ".sna"
    dlgCommon.FileName = ""
    dlgCommon.Filter = "All Spectrum Files (*.sna;*.z80;*.rom)|*.sna;*.z80;*.rom|SNA snapshots (*.sna)|*.sna|Z80 shapshots (*.z80)|*.z80|ROM images *.rom)|*.rom|All Files|*.*"
    dlgCommon.Flags = cdlOFNFileMustExist Or cdlOFNExplorer Or cdlOFNLongNames
    dlgCommon.CancelError = True
    dlgCommon.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    End If
    
    If dlgCommon.FileName <> "" Then
        Select Case LCase$(Right$(dlgCommon.FileName, 4))
        Case ".z80"
            LoadZ80Snap dlgCommon.FileName
        Case ".rom"
            LoadROM dlgCommon.FileName
            Z80Reset
        Case ".sna"
            LoadSNASnap dlgCommon.FileName
        Case Else
            ' try opening it as a SNA file
            LoadSNASnap dlgCommon.FileName
        End Select
    End If
End Sub



Private Sub Form_Unload(Cancel As Integer)
    timeEndPeriod 1
    End
End Sub


Private Sub mnuFile_Click(Index As Integer)
    Select Case Index
    Case 1 ' Open
        FileOpenDialog
    Case 3 ' Reset
        Z80Reset
    Case 5 ' Exit
        Unload Me
    End Select
End Sub

Private Sub mnuHelp_Click(Index As Integer)
    Select Case Index
    Case 1 ' // Show spectrum keyboard layout
        frmKeyboard.Show
    Case 3 ' // About... Dialog
        frmAbout.Show 1
    End Select
End Sub

Private Sub mnuOptions_Click(Index As Integer)
    Select Case Index
    Case 1
        frmOptions.Show 1
    Case 2
        frmDisplayOpt.Show 1
    End Select
End Sub

Private Sub picDisplay_KeyDown(KeyCode As Integer, Shift As Integer)
    If (Shift And 4) Then Exit Sub
    doKey True, KeyCode, Shift
End Sub

Private Sub picDisplay_KeyUp(KeyCode As Integer, Shift As Integer)
    doKey False, KeyCode, Shift
End Sub






