Attribute VB_Name = "modSpectrum"
' /*******************************************************************************
'   modSpectrum.bas within vbSpec.vbp
'
'   Routines for emulating the spectrum hardware; displaying the
'   video memory (0x4000 - 0x5AFF), reading the keyboard (port
'   0xFE), and displaying the border colour (out (xxFE),x)
'
'   Author: Chris Cowley <ccowley@grok.co.uk>
'
'   Copyright (C)1999  Grok Developments Ltd.
'   http://www.grok.co.uk/
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' *******************************************************************************/

Option Explicit

Public glNewBorder As Long


Function doKey(down As Boolean, ascii As Integer, mods As Integer) As Boolean
    Dim CAPS As Boolean, SYMB As Boolean, Shift As Boolean
    
    CAPS = mods And 1
    SYMB = mods And 2
    
    ' // Change control versions of keys to lower case
    If (ascii >= 1) And (ascii <= &H27&) And SYMB Then
        ascii = ascii + Asc("a") - 1
    End If
    
    If CAPS Then keyCAPS_V = (keyCAPS_V And (Not 1&)) Else keyCAPS_V = (keyCAPS_V Or 1&)
    If SYMB Then keyB_SPC = (keyB_SPC And (Not 2&)) Else keyB_SPC = (keyB_SPC Or 2&)

    Select Case ascii
    Case 8 ' Backspace
        If down Then
            key6_0 = (key6_0 And (Not 1&))
            keyCAPS_V = (keyCAPS_V And (Not 1&))
        Else
            key6_0 = (key6_0 Or 1&)
            If Not CAPS Then
                keyCAPS_V = (keyCAPS_V Or 1&)
            End If
        End If
    Case 65 ' A
        If down Then keyA_G = (keyA_G And (Not 1&)) Else keyA_G = (keyA_G Or 1&)
    Case 66 ' B
        If down Then keyB_SPC = (keyB_SPC And (Not 16&)) Else keyB_SPC = (keyB_SPC Or 16&)
    Case 67 ' C
        If down Then keyCAPS_V = (keyCAPS_V And (Not 8&)) Else keyCAPS_V = (keyCAPS_V Or 8&)
    Case 68 ' D
        If down Then keyA_G = (keyA_G And (Not 4&)) Else keyA_G = (keyA_G Or 4&)
    Case 69 ' E
        If down Then keyQ_T = (keyQ_T And (Not 4&)) Else keyQ_T = (keyQ_T Or 4&)
    Case 70 ' F
        If down Then keyA_G = (keyA_G And (Not 8&)) Else keyA_G = (keyA_G Or 8&)
    Case 71 ' G
        If down Then keyA_G = (keyA_G And (Not 16&)) Else keyA_G = (keyA_G Or 16&)
    Case 72 ' H
        If down Then keyH_ENT = (keyH_ENT And (Not 16&)) Else keyH_ENT = (keyH_ENT Or 16&)
    Case 73 ' I
        If down Then keyY_P = (keyY_P And (Not 4&)) Else keyY_P = (keyH_ENT Or 4&)
    Case 74 ' J
        If down Then keyH_ENT = (keyH_ENT And (Not 8&)) Else keyH_ENT = (keyH_ENT Or 8&)
    Case 75 ' K
        If down Then keyH_ENT = (keyH_ENT And (Not 4&)) Else keyH_ENT = (keyH_ENT Or 4&)
    Case 76 ' L
        If down Then keyH_ENT = (keyH_ENT And (Not 2&)) Else keyH_ENT = (keyH_ENT Or 2&)
    Case 77 ' M
        If down Then keyB_SPC = (keyB_SPC And (Not 4&)) Else keyB_SPC = (keyB_SPC Or 4&)
    Case 78 ' N
        If down Then keyB_SPC = (keyB_SPC And (Not 8&)) Else keyB_SPC = (keyB_SPC Or 8&)
    Case 79 ' O
        If down Then keyY_P = (keyY_P And (Not 2&)) Else keyY_P = (keyY_P Or 2&)
    Case 80 ' P
        If down Then keyY_P = (keyY_P And (Not 1&)) Else keyY_P = (keyY_P Or 1&)
    Case 81 ' Q
        If down Then keyQ_T = (keyQ_T And (Not 1&)) Else keyQ_T = (keyQ_T Or 1&)
    Case 82 ' R
        If down Then keyQ_T = (keyQ_T And (Not 8&)) Else keyQ_T = (keyQ_T Or 8&)
    Case 83 ' S
        If down Then keyA_G = (keyA_G And (Not 2&)) Else keyA_G = (keyA_G Or 2&)
    Case 84 ' T
        If down Then keyQ_T = (keyQ_T And (Not 16&)) Else keyQ_T = (keyQ_T Or 16&)
    Case 85 ' U
        If down Then keyY_P = (keyY_P And (Not 8&)) Else keyY_P = (keyY_P Or 8&)
    Case 86 ' V
        If down Then keyCAPS_V = (keyCAPS_V And (Not 16&)) Else keyCAPS_V = (keyCAPS_V Or 16&)
    Case 87 ' W
        If down Then keyQ_T = (keyQ_T And (Not 2&)) Else keyQ_T = (keyQ_T Or 2&)
    Case 88 ' X
        If down Then keyCAPS_V = (keyCAPS_V And (Not 4&)) Else keyCAPS_V = (keyCAPS_V Or 4&)
    Case 89 ' Y
        If down Then keyY_P = (keyY_P And (Not 16&)) Else keyY_P = (keyY_P Or 16&)
    Case 90 ' Z
        If down Then keyCAPS_V = (keyCAPS_V And (Not 2&)) Else keyCAPS_V = (keyCAPS_V Or 2&)
    Case 48 ' 0
        If down Then key6_0 = (key6_0 And (Not 1&)) Else key6_0 = (key6_0 Or 1&)
    Case 49 ' 1
        If down Then key1_5 = (key1_5 And (Not 1&)) Else key1_5 = (key1_5 Or 1&)
    Case 50 ' 2
        If down Then key1_5 = (key1_5 And (Not 2&)) Else key1_5 = (key1_5 Or 2&)
    Case 51 ' 3
        If down Then key1_5 = (key1_5 And (Not 4&)) Else key1_5 = (key1_5 Or 4&)
    Case 52 ' 4
        If down Then key1_5 = (key1_5 And (Not 8&)) Else key1_5 = (key1_5 Or 8&)
    Case 53 ' 5
        If down Then key1_5 = (key1_5 And (Not 16&)) Else key1_5 = (key1_5 Or 16&)
    Case 54 ' 6
        If down Then key6_0 = (key6_0 And (Not 16&)) Else key6_0 = (key6_0 Or 16&)
    Case 55 ' 7
        If down Then key6_0 = (key6_0 And (Not 8&)) Else key6_0 = (key6_0 Or 8&)
    Case 56 ' 8
        If down Then key6_0 = (key6_0 And (Not 4&)) Else key6_0 = (key6_0 Or 4&)
    Case 57 ' 9
        If down Then key6_0 = (key6_0 And (Not 2&)) Else key6_0 = (key6_0 Or 2&)
    Case 96 ' Keypad 0
        If down Then key6_0 = (key6_0 And (Not 1&)) Else key6_0 = (key6_0 Or 1&)
    Case 97 ' Keypad 1
        If down Then key1_5 = (key1_5 And (Not 1&)) Else key1_5 = (key1_5 Or 1&)
    Case 98 ' Keypad 2
        If down Then key1_5 = (key1_5 And (Not 2&)) Else key1_5 = (key1_5 Or 2&)
    Case 99 ' Keypad 3
        If down Then key1_5 = (key1_5 And (Not 4&)) Else key1_5 = (key1_5 Or 4&)
    Case 100 ' Keypad 4
        If down Then key1_5 = (key1_5 And (Not 8&)) Else key1_5 = (key1_5 Or 8&)
    Case 101 ' Keypad 5
        If down Then key1_5 = (key1_5 And (Not 16&)) Else key1_5 = (key1_5 Or 16&)
    Case 102 ' Keypad 6
        If down Then key6_0 = (key6_0 And (Not 16&)) Else key6_0 = (key6_0 Or 16&)
    Case 103 ' Keypad 7
        If down Then key6_0 = (key6_0 And (Not 8&)) Else key6_0 = (key6_0 Or 8&)
    Case 104 ' Keypad 8
        If down Then key6_0 = (key6_0 And (Not 4&)) Else key6_0 = (key6_0 Or 4&)
    Case 105 ' Keypad 9
        If down Then key6_0 = (key6_0 And (Not 2&)) Else key6_0 = (key6_0 Or 2&)
    Case 106 ' Keypad *
        If down Then
            keyB_SPC = (keyB_SPC And Not (18&))
        Else
            If SYMB Then
                keyB_SPC = (keyB_SPC Or 16&)
            Else
                keyB_SPC = (keyB_SPC Or 18&)
            End If
        End If
    Case 107 ' Keypad +
        If down Then
            keyH_ENT = (keyH_ENT And (Not 4&))
            keyB_SPC = (keyB_SPC And (Not 2&))
        Else
            keyH_ENT = (keyH_ENT Or 4&)
            If Not SYMB Then
                keyB_SPC = (keyB_SPC Or 2&)
            End If
        End If
    Case 109 ' Keypad -
        If down Then
            keyH_ENT = (keyH_ENT And (Not 8&))
            keyB_SPC = (keyB_SPC And (Not 2&))
        Else
            keyH_ENT = (keyH_ENT Or 8&)
            If Not SYMB Then
                keyB_SPC = (keyB_SPC Or 2&)
            End If
        End If
    Case 110 ' Keypad .
        If down Then
            keyB_SPC = (keyB_SPC And (Not 6&))
        Else
            If SYMB Then
                keyB_SPC = (keyB_SPC Or 4&)
            Else
                keyB_SPC = (keyB_SPC Or 6&)
            End If
        End If
    Case 111 ' Keypad /
        If down Then
            keyCAPS_V = (keyCAPS_V And (Not 16&))
            keyB_SPC = (keyB_SPC And (Not 2&))
        Else
            keyCAPS_V = (keyCAPS_V Or 16&)
            If Not SYMB Then
                keyB_SPC = (keyB_SPC Or 2&)
            End If
        End If
    Case 37 ' Left
        If down Then
            key1_5 = (key1_5 And (Not 16&))
            keyCAPS_V = (keyCAPS_V And (Not 1&))
        Else
            key1_5 = (key1_5 Or 16&)
            If Not SYMB Then
                keyB_SPC = (keyB_SPC Or 2&)
            End If
        End If
    Case 38 ' Up
        If down Then
            key6_0 = (key6_0 And (Not 8&))
            keyCAPS_V = (keyCAPS_V And (Not 1&))
        Else
            key6_0 = (key6_0 Or 8&)
            If Not CAPS Then
                keyCAPS_V = (keyCAPS_V Or 1&)
            End If
        End If
    Case 39 ' Right
        If down Then
            key6_0 = (key6_0 And (Not 4&))
            keyCAPS_V = (keyCAPS_V And (Not 1&))
        Else
            key6_0 = (key6_0 Or 4&)
            If Not CAPS Then
                keyCAPS_V = (keyCAPS_V Or 1&)
            End If
        End If
    Case 40 ' Down
        If down Then
            key6_0 = (key6_0 And (Not 16&))
            keyCAPS_V = (keyCAPS_V And (Not 1&))
        Else
            key6_0 = (key6_0 Or 16&)
            If Not CAPS Then
                keyCAPS_V = (keyCAPS_V Or 1&)
            End If
        End If
    Case 13 ' RETURN
        If down Then keyH_ENT = (keyH_ENT And (Not 1&)) Else keyH_ENT = (keyH_ENT Or 1&)
    Case 32 ' SPACE BAR
        If down Then keyB_SPC = (keyB_SPC And (Not 1&)) Else keyB_SPC = (keyB_SPC Or 1&)
    Case 187 ' =/+ key
        If down Then
            If CAPS Then
                keyH_ENT = (keyH_ENT And (Not 4&))
            Else
                keyH_ENT = (keyH_ENT And (Not 2&))
            End If
            keyB_SPC = (keyB_SPC And (Not 2&))
            keyCAPS_V = (keyCAPS_V Or 1&)
        Else
            keyH_ENT = (keyH_ENT Or 4&)
            keyH_ENT = (keyH_ENT Or 2&)
            keyB_SPC = (keyB_SPC Or 2&)
        End If
    Case 189 ' -/_ key
        If down Then
            If CAPS Then
                key6_0 = (key6_0 And (Not 1&))
            Else
                keyH_ENT = (keyH_ENT And (Not 8&))
            End If
            keyB_SPC = (keyB_SPC And (Not 2&))
            keyCAPS_V = (keyCAPS_V Or 1&)
        Else
            key6_0 = (key6_0 Or 1&)     ' // Release the Spectrum's '0' key
            keyH_ENT = (keyH_ENT Or 8&) ' // Release the Spectrum's 'J' key
            keyB_SPC = (keyB_SPC Or 2&) ' // Release the Symbol Shift key
        End If
    Case 186 ' ;/: keys
        If down Then
            If CAPS Then
                keyCAPS_V = (keyCAPS_V And (Not 2&))
            Else
                keyY_P = (keyY_P And (Not 2&))
            End If
            keyB_SPC = (keyB_SPC And (Not 2&))
            keyCAPS_V = (keyCAPS_V Or 1&)
        Else
            keyCAPS_V = (keyCAPS_V Or 2&)
            keyY_P = (keyY_P Or 2&)
            keyB_SPC = (keyB_SPC Or 2&)
        End If
    Case Else
        doKey = False
    End Select

    doKey = True
End Function

Sub plot(addr As Long, newByte As Long)
    Dim lne As Long, i As Long, X As Long
    
    If addr < 22528 Then
        ' // Alter a pixel
        lne = ((addr \ 256&) And &H7&) Or _
                  ((addr \ 4&) And &H38&) Or _
                  ((addr \ 32&) And &HC0&)
        ScrnLines(lne, 32) = True
        ScrnLines(lne, addr And 31) = True
    Else
        ' // Alter an attribute
        lne = ((addr - 22528) \ 32)
        X = addr Mod 32
        For i = lne * 8 To lne * 8 + 7
            ScrnLines(i, 32) = True
            ScrnLines(i, X) = True
        Next i
    End If
    ScrnNeedRepaint = True
End Sub

Function inb(port As Long) As Long
    Dim res As Long
       
    res = &HFF&
    If (port And &H1&) = 0 Then
        If (port And &H8000&) = 0 Then res = res And keyB_SPC
        If (port And &H4000&) = 0 Then res = res And keyH_ENT
        If (port And &H2000&) = 0 Then res = res And keyY_P
        If (port And &H1000&) = 0 Then res = res And key6_0
        If (port And &H800&) = 0 Then res = res And key1_5
        If (port And &H400&) = 0 Then res = res And keyQ_T
        If (port And &H200&) = 0 Then res = res And keyA_G
        If (port And &H100&) = 0 Then res = res And keyCAPS_V
        inb = res
    Else
        inb = 0
    End If
    
End Function

Sub outb(port As Long, outbyte As Long, tstates As Long)
    If (port And &H1&) = 0 Then
        If frmMainWnd.BackColor <> glNormalColor(outbyte And &H7&) Then
            frmMainWnd.BackColor = glNormalColor(outbyte And &H7&)
        End If
    End If
End Sub


Public Sub refreshFlashChars()
    Dim addr As Long, lne As Long, i As Long
    
    bFlashInverse = Not (bFlashInverse)
    
    For addr = 22528 To 23295
        If mem(addr) And 128 Then
            lne = ((addr - 22528) \ 32)
            For i = lne * 8 To lne * 8 + 7
                ScrnLines(i, 32) = True
                ScrnLines(i, addr And 31) = True
            Next i
            ScrnNeedRepaint = True
        End If
    Next addr
End Sub

Sub screenPaint()
    Dim lne As Long, X As Long
    Dim sbyte As Long, abyte As Long, fcolor As Long, bcolor As Long
    Dim lXBit As Long, lXOffset As Long, ret As Long
    
    ' // Only update screen if necessary
    If ScrnNeedRepaint = False Then Exit Sub
    
    gpicDisplay.Visible = False
    
    #If USE_WINAPI Then
        For lne = 0 To 191
            If ScrnLines(lne, 32) = True Then
                For X = 0 To 31
                    If ScrnLines(lne, X) = True Then
                        sbyte = mem(glScreenMem(lne, X))
                        abyte = mem(22528 + (lne \ 8) * 32 + X)
                        
                        If abyte And 64 Then
                           fcolor = (abyte And 7) + 8
                           bcolor = ((abyte And 56) \ 8) + 8
                        Else
                           fcolor = (abyte And 7)
                           bcolor = ((abyte And 56) \ 8)
                        End If
                        If (abyte And 128) And (bFlashInverse) Then
                            ' // Swap fore- and back-colours
                            lXBit = fcolor
                            fcolor = bcolor
                            bcolor = lXBit
                        End If
                        
                        ' // Use the SetPixel API function instead of PSet to improve performance
                        lXBit = 128
                        lXOffset = 0
                        Do
                            If (sbyte And lXBit) = lXBit Then
                                cBufferBits(lne * 256 + X * 8 + lXOffset) = fcolor
                            Else
                                cBufferBits(lne * 256 + X * 8 + lXOffset) = bcolor
                            End If
                            lXBit = lXBit / 2
                            lXOffset = lXOffset + 1
                        Loop Until lXBit = 0
                    End If
                    ScrnLines(lne, X) = False
                Next X
                ScrnLines(lne, 32) = False
            End If
        Next lne
        
        StretchDIBits gpicDisplay.hdc, 0, glDisplayVSource, glDisplayWidth, glDisplayVSize, 0, 0, 256, 192, cBufferBits(0), bmiBuffer, DIB_RGB_COLORS, SRCCOPY
    #Else
        For lne = 0 To 191
            If ScrnLines(lne, 32) = True Then
                For X = 0 To 31
                    If ScrnLines(lne, X) = True Then
                        sbyte = mem(glScreenMem(lne, X))
                        abyte = mem(22528 + (lne \ 8) * 32 + X)
                        
                        If abyte And 64 Then
                           fcolor = glBrightColor(abyte And 7)
                           bcolor = glBrightColor((abyte And 56) \ 8)
                        Else
                           fcolor = glNormalColor(abyte And 7)
                           bcolor = glNormalColor((abyte And 56) \ 8)
                        End If
                        If (abyte And 128) And (bFlashInverse) Then
                            ' // Swap fore- and back-colours
                            lXBit = fcolor
                            fcolor = bcolor
                            bcolor = lXBit
                        End If
                        
                        ' // Use the SetPixel API function instead of PSet to improve performance
                        lXBit = 128
                        lXOffset = 0
                        Do
                            If (sbyte And lXBit) = lXBit Then
                                gpicDisplay.PSet (X * 8 + lXOffset, lne), fcolor
                            Else
                                gpicDisplay.PSet (X * 8 + lXOffset, lne), bcolor
                            End If
                            lXBit = lXBit / 2
                            lXOffset = lXOffset + 1
                        Loop Until lXBit = 0
                    End If
                    ScrnLines(lne, X) = False
                Next X
                ScrnLines(lne, 32) = False
            End If
        Next lne
    #End If
    
    gpicDisplay.Visible = True
    ScrnNeedRepaint = False
End Sub




