Attribute VB_Name = "modZ80"
' /*******************************************************************************
'   modZ80.bas within vbSpec.vbp
'
'   Complete Z80 emulation, including (as far as I know) the
'   correct emulation of bits 3 and 5 of F, and undocumented ops.
'   Please mail me if you find any bugs in the emulation!
'
'   Author: Chris Cowley <ccowley@grok.co.uk>
'
'   Copyright (C)1999-2000 Grok Developments Ltd.
'   http://www.grok.co.uk/
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' *******************************************************************************/

Option Explicit
Private Sub adc_a(b As Long)
    Dim wans As Long, ans As Long, c As Long
    
    If fC Then c = 1
    
    wans = regA + b + c
    ans = wans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fC = (wans And &H100&) <> 0
    fPV = ((regA Xor ((Not b) And &HFFFF&)) And (regA Xor ans) And &H80&) <> 0

    fH = (((regA And &HF&) + (b And &HF&) + c) And F_H) <> 0
    fN = False
     
    regA = ans
End Sub
Private Function adc16(a As Long, b As Long)
    Dim c As Long, lans As Long, ans As Long
    
    If fC Then c = 1
    
    lans = a + b + c
    ans = lans And &HFFFF&

    fS = (ans And (F_S * 256&)) <> 0
    f3 = (ans And (F_3 * 256&)) <> 0
    f5 = (ans And (F_5 * 256&)) <> 0
    fZ = (ans = 0)
    fC = (lans And &H10000) <> 0
    fPV = ((a Xor ((Not b) And &HFFFF&)) And (a Xor ans) And &H8000&) <> 0
    fH = (((a And &HFFF&) + (b And &HFFF&) + c) And &H1000&) <> 0
    fN = False
    
    adc16 = ans
End Function

Private Sub add_a(b As Long)
    Dim wans As Long, ans As Long
    
    wans = regA + b
    ans = wans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fC = (wans And &H100&) <> 0
    fPV = ((regA Xor ((Not (b)) And &HFFFF&)) And (regA Xor ans) And &H80&) <> 0
    fH = (((regA And &HF&) + (b And &HF&)) And F_H) <> 0
    fN = False
       
    regA = ans
End Sub
Private Function add16(a As Long, b As Long)
    Dim lans As Long
    Dim ans As Long
        
    lans = a + b
    ans = lans And &HFFFF&

    f3 = (ans And (F_3 * 256&)) <> 0
    f5 = (ans And (F_5 * 256&)) <> 0
    fC = (lans And &H10000) <> 0
    fH = (((a And &HFFF&) + (b And &HFFF&)) And &H1000&) <> 0
    fN = False
    
    add16 = ans
End Function

Private Sub and_a(b As Long)
    regA = (regA And b)
    
    fS = (regA And F_S) <> 0
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fH = True
    fPV = Parity(regA)
    fZ = (regA = 0)
    fN = False
    fC = False
End Sub

Private Sub bit(b As Long, r As Long)
    Dim IsbitSet As Boolean
    
    IsbitSet = (r And b) <> 0
    fN = False
    fH = True
    f3 = (r And F_3) <> 0
    f5 = (r And F_5) <> 0
    
    If b = F_S Then fS = IsbitSet Else fS = False
    
    fZ = Not IsbitSet
    fPV = fZ
End Sub

Private Function bitRes(bit As Long, val As Long) As Long
    bitRes = val And (Not (bit) And &HFFFF&)
End Function

Public Function bitSet(bit As Long, val As Long) As Long
    bitSet = val Or bit
End Function

Private Sub ccf()
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fH = fC
    fN = False
    fC = Not fC
End Sub

Public Sub cp_a(b As Long)
    Dim a As Long, wans As Long, ans As Long
    
    a = regA
    wans = a - b
    ans = wans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (b And F_3) <> 0
    f5 = (b And F_5) <> 0
    fN = True
    fZ = (ans = 0)
    fC = (wans And &H100&) <> 0
    fH = (((a And &HF&) - (b And &HF&)) And F_H) <> 0
    fPV = ((a Xor b) And (a Xor ans) And &H80&) <> 0
End Sub

Private Sub cpl_a()
    regA = (regA Xor &HFF&) And &HFF&
    
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fH = True
    fN = True
End Sub

Private Sub daa_a()
    Dim ans As Long, incr As Long, carry As Boolean
    
    ans = regA
    carry = fC
    
    If (fH = True) Or ((ans And &HF&) > &H9&) Then
        incr = incr Or &H6&
    End If
    
    If (carry = True) Or (ans > &H9F&) Then
        incr = incr Or &H60&
    End If
    
    If ((ans > &H8F&) And ((ans And &HF&) > 9&)) Then
        incr = incr Or &H60&
    End If
    
    If (ans > &H99&) Then
        carry = True
    End If
    If (fN = True) Then
        sub_a incr
    Else
        add_a incr
    End If
    
    ans = regA
    fC = carry
    fPV = Parity(ans)
End Sub

Private Function dec16(a As Long) As Long
    dec16 = (a - 1) And &HFFFF&
End Function

Private Sub ex_af_af()
    Dim t As Long
    
    t = getAF
    setAF regAF_
    regAF_ = t
End Sub

Private Function execute_cb() As Long
    Dim xxx As Long
    
    ' // REFRESH 1
    intRTemp = intRTemp + 1
    
    xxx = nxtpcb
    Select Case xxx
    Case 0 ' RLC B
        regB = rlc(regB)
        execute_cb = 8
    Case 1 ' RLC C
        regC = rlc(regC)
        execute_cb = 8
    Case 2 ' RLC D
        setD rlc(getD)
        execute_cb = 8
    Case 3 ' RLC E
        setE rlc(getE)
        execute_cb = 8
    Case 4 ' RLC H
        setH rlc(getH)
        execute_cb = 8
    Case 5 ' RLC L
        setL rlc(getL)
        execute_cb = 8
    Case 6 ' RLC (HL)
        pokeb regHL, rlc(peekb(regHL))
        execute_cb = 15
    Case 7 ' RLC A
        regA = rlc(regA)
        execute_cb = 8
    Case 8 ' RRC B
        regB = rrc(regB)
        execute_cb = 8
    Case 9 ' RRC C
        regC = rrc(regC)
        execute_cb = 8
    Case 10 ' RRC D
        setD rrc(getD)
        execute_cb = 8
    Case 11 ' RRC E
        setE rrc(getE)
        execute_cb = 8
    Case 12 ' RRC H
        setH rrc(getH)
        execute_cb = 8
    Case 13 ' RRC L
        setL rrc(getL)
        execute_cb = 8
    Case 14 ' RRC (HL)
        pokeb regHL, rrc(peekb(regHL))
        execute_cb = 15
    Case 15 ' RRC A
        regA = rrc(regA)
        execute_cb = 8
    Case 16 ' RL B
        regB = rl(regB)
        execute_cb = 8
    Case 17 ' RL C
        regC = rl(regC)
        execute_cb = 8
    Case 18 ' RL D
        setD rl(getD)
        execute_cb = 8
    Case 19 ' RL E
        setE rl(getE)
        execute_cb = 8
    Case 20 ' RL H
        setH rl(getH)
        execute_cb = 8
    Case 21 ' RL L
        setL rl(getL)
        execute_cb = 8
    Case 22 ' RL (HL)
        pokeb regHL, rl(peekb(regHL))
        execute_cb = 15
    Case 23 ' RL A
        regA = rl(regA)
        execute_cb = 8
    Case 24 ' RR B
        regB = rr(regB)
        execute_cb = 8
    Case 25 ' RR C
        regC = rr(regC)
        execute_cb = 8
    Case 26 ' RR D
        setD rr(getD)
        execute_cb = 8
    Case 27 ' RR E
        setE rr(getE)
        execute_cb = 8
    Case 28 ' RR H
        setH rr(getH)
        execute_cb = 8
    Case 29 ' RR L
        setL rr(getL)
        execute_cb = 8
    Case 30 ' RR (HL)
        pokeb regHL, rr(peekb(regHL))
        execute_cb = 15
    Case 31 ' RR A
        regA = rr(regA)
        execute_cb = 8
    Case 32 ' SLA B
        regB = sla(regB)
        execute_cb = 8
    Case 33 ' SLA C
        regC = sla(regC)
        execute_cb = 8
    Case 34 ' SLA D
        setD sla(getD)
        execute_cb = 8
    Case 35 ' SLA E
        setE sla(getE)
        execute_cb = 8
    Case 36 ' SLA H
        setH sla(getH)
        execute_cb = 8
    Case 37 ' SLA L
        setL sla(getL)
        execute_cb = 8
    Case 38 ' SLA (HL)
        pokeb regHL, sla(peekb(regHL))
        execute_cb = 15
    Case 39 ' SLA A
        regA = sla(regA)
        execute_cb = 8
    Case 40 ' SRA B
        regB = sra(regB)
        execute_cb = 8
    Case 41 ' SRA C
        regC = sra(regC)
        execute_cb = 8
    Case 42 ' SRA D
        setD sra(getD)
        execute_cb = 8
    Case 43 ' SRA E
        setE sra(getE)
        execute_cb = 8
    Case 44 ' SRA H
        setH sra(getH)
        execute_cb = 8
    Case 45  ' SRA L
        setL sra(getL)
        execute_cb = 8
    Case 46 ' SRA (HL)
        pokeb regHL, sra(peekb(regHL))
        execute_cb = 15
    Case 47 ' SRA A
        regA = sra(regA)
        execute_cb = 8
    Case 48 ' SLS B
        regB = sls(regB)
        execute_cb = 8
    Case 49 ' SLS C
        regC = sls(regC)
        execute_cb = 8
    Case 50 ' SLS D
        setD sls(getD)
        execute_cb = 8
    Case 51 ' SLS E
        setE sls(getE)
        execute_cb = 8
    Case 52 ' SLS H
        setH sls(getH)
        execute_cb = 8
    Case 53 ' SLS L
        setL sls(getL)
        execute_cb = 8
    Case 54 ' SLS (HL)
        pokeb regHL, sls(peekb(regHL))
        execute_cb = 15
    Case 55 ' SLS A
        regA = sls(regA)
        execute_cb = 8
    Case 56 ' SRL B
        regB = srl(regB)
        execute_cb = 8
    Case 57 ' SRL C
        regC = srl(regC)
        execute_cb = 8
    Case 58 ' SRL D
        setD srl(getD)
        execute_cb = 8
    Case 59 ' SRL E
        setE srl(getE)
        execute_cb = 8
    Case 60 ' SRL H
        setH srl(getH)
        execute_cb = 8
    Case 61 ' SRL L
        setL srl(getL)
        execute_cb = 8
    Case 62 ' SRL (HL)
        pokeb regHL, srl(peekb(regHL))
        execute_cb = 15
    Case 63 ' SRL A
        regA = srl(regA)
        execute_cb = 8
    Case 64 ' BIT 0,B
        bit &H1&, regB
        execute_cb = 8
    Case 65 ' BIT 0,C
        bit 1&, regC
        execute_cb = 8
    Case 66 ' BIT 0,D
        bit 1&, getD
        execute_cb = 8
    Case 67 ' BIT 0,E
        bit 1&, getE
        execute_cb = 8
    Case 68 ' BIT 0,H
        bit 1&, getH
        execute_cb = 8
    Case 69 ' BIT 0,L
        bit 1&, getL
        execute_cb = 8
    Case 70 ' BIT 0,(HL)
        bit 1&, peekb(regHL)
        execute_cb = 12
    Case 71 ' BIT 0,A
        bit 1&, regA
        execute_cb = 8
    Case 72 ' BIT 1,B
        bit 2&, regB
        execute_cb = 8
    Case 73 ' BIT 1,C
        bit 2&, regC
        execute_cb = 8
    Case 74 ' BIT 1,D
        bit 2&, getD
        execute_cb = 8
    Case 75 ' BIT 1,E
        bit 2&, getE
        execute_cb = 8
    Case 76 ' BIT 1,H
        bit 2&, getH
        execute_cb = 8
    Case 77 ' BIT 1,L
        bit 2&, getL
        execute_cb = 8
    Case 78 ' BIT 1,(HL)
        bit 2&, peekb(regHL)
        execute_cb = 12
    Case 79 ' BIT 1,A
        bit 2&, regA
        execute_cb = 8
    Case 80 ' BIT 2,B
        bit 4&, regB
        execute_cb = 8
    Case 81 ' BIT 2,C
        bit 4&, regC
        execute_cb = 8
    Case 82 ' BIT 2,D
        bit 4&, getD
        execute_cb = 8
    Case 83 ' BIT 2,E
        bit 4&, getE
        execute_cb = 8
    Case 84 ' BIT 2,H
        bit 4&, getH
        execute_cb = 8
    Case 85 ' BIT 2,L
        bit 4&, getL
        execute_cb = 8
    Case 86 ' BIT 2,(HL)
        bit 4&, peekb(regHL)
        execute_cb = 12
    Case 87 ' BIT 2,A
        bit 4&, regA
        execute_cb = 8
    Case 88 ' BIT 3,B
        bit 8&, regB
        execute_cb = 8
    Case 89 ' BIT 3,C
        bit 8&, regC
        execute_cb = 8
    Case 90 ' BIT 3,D
        bit 8&, getD
        execute_cb = 8
    Case 91 ' BIT 3,E
        bit 8&, getE
        execute_cb = 8
    Case 92 ' BIT 3,H
        bit 8&, getH
        execute_cb = 8
    Case 93 ' BIT 3,L
        bit 8&, getL
        execute_cb = 8
    Case 94 ' BIT 3,(HL)
        bit 8&, peekb(regHL)
        execute_cb = 12
    Case 95 ' BIT 3,A
        bit 8&, regA
        execute_cb = 8
    Case 96 ' BIT 4,B
        bit &H10&, regB
        execute_cb = 8
    Case 97 ' BIT 4,C
        bit &H10&, regC
        execute_cb = 8
    Case 98 ' BIT 4,D
        bit &H10&, getD
        execute_cb = 8
    Case 99 ' BIT 4,E
        bit &H10&, getE
        execute_cb = 8
    Case 100 ' BIT 4,H
        bit &H10&, getH
        execute_cb = 8
    Case 101 ' BIT 4,L
        bit &H10&, getL
        execute_cb = 8
    Case 102 ' BIT 4,(HL)
        bit &H10&, peekb(regHL)
        execute_cb = 12
    Case 103 ' BIT 4,A
        bit &H10&, regA
        execute_cb = 8
    Case 104 ' BIT 5,B
        bit &H20&, regB
        execute_cb = 8
    Case 105 ' BIT 5,C
        bit &H20&, regC
        execute_cb = 8
    Case 106 ' BIT 5,D
        bit &H20&, getD
        execute_cb = 8
    Case 107 ' BIT 5,E
        bit &H20&, getE
        execute_cb = 8
    Case 108 ' BIT 5,H
        bit &H20&, getH
        execute_cb = 8
    Case 109 ' BIT 5,L
        bit &H20&, getL
        execute_cb = 8
    Case 110 ' BIT 5,(HL)
        bit &H20&, peekb(regHL)
        execute_cb = 12
    Case 111 ' BIT 5,A
        bit &H20&, regA
        execute_cb = 8
    Case 112 ' BIT 6,B
        bit &H40&, regB
        execute_cb = 8
    Case 113 ' BIT 6,C
        bit &H40&, regC
        execute_cb = 8
    Case 114 ' BIT 6,D
        bit &H40&, getD
        execute_cb = 8
    Case 115 ' BIT 6,E
        bit &H40&, getE
        execute_cb = 8
    Case 116 ' BIT 6,H
        bit &H40&, getH
        execute_cb = 8
    Case 117 ' BIT 6,L
        bit &H40&, getL
        execute_cb = 8
    Case 118 ' BIT 6,(HL)
        bit &H40&, peekb(regHL)
        execute_cb = 12
    Case 119 ' BIT 6,A
        bit &H40&, regA
        execute_cb = 8
    Case 120 ' BIT 7,B
        bit &H80&, regB
        execute_cb = 8
    Case 121 ' BIT 7,C
        bit &H80&, regC
        execute_cb = 8
    Case 122 ' BIT 7,D
        bit &H80&, getD
        execute_cb = 8
    Case 123 ' BIT 7,E
        bit &H80&, getE
        execute_cb = 8
    Case 124 ' BIT 7,H
        bit &H80&, getH
        execute_cb = 8
    Case 125 ' BIT 7,L
        bit &H80&, getL
        execute_cb = 8
    Case 126 ' BIT 7,(HL)
        bit &H80&, peekb(regHL)
        execute_cb = 12
    Case 127 ' BIT 7,A
        bit &H80&, regA
        execute_cb = 8
    Case 128 ' RES 0,B
        regB = bitRes(1&, regB)
        execute_cb = 8
    Case 129 ' RES 0,C
        regC = bitRes(1&, regC)
        execute_cb = 8
    Case 130 ' RES 0,D
        setD bitRes(1&, getD)
        execute_cb = 8
    Case 131 ' RES 0,E
        setE bitRes(1&, getE)
        execute_cb = 8
    Case 132 ' RES 0,H
        setH bitRes(1&, getH)
        execute_cb = 8
    Case 133 ' RES 0,L
        setL bitRes(1&, getL)
        execute_cb = 8
    Case 134 ' RES 0,(HL)
        pokeb regHL, bitRes(&H1&, peekb(regHL))
        execute_cb = 15
    Case 135 ' RES 0,A
        regA = bitRes(1&, regA)
        execute_cb = 8
    Case 136 ' RES 1,B
        regB = bitRes(2&, regB)
        execute_cb = 8
    Case 137 ' RES 1,C
        regC = bitRes(2&, regC)
        execute_cb = 8
    Case 138 ' RES 1,D
        setD bitRes(2&, getD)
        execute_cb = 8
    Case 139 ' RES 1,E
        setE bitRes(2&, getE)
        execute_cb = 8
    Case 140 ' RES 1,H
        setH bitRes(2&, getH)
        execute_cb = 8
    Case 141 ' RES 1,L
        setL bitRes(2&, getL)
        execute_cb = 8
    Case 142 ' RES 1,(HL)
        pokeb regHL, bitRes(2&, peekb(regHL))
        execute_cb = 15
    Case 143 ' RES 1,A
        regA = bitRes(2&, regA)
        execute_cb = 8
    Case 144 ' RES 2,B
        regB = bitRes(4&, regB)
        execute_cb = 8
    Case 145 ' RES 2,C
        regC = bitRes(4&, regC)
        execute_cb = 8
    Case 146 ' RES 2,D
        setD bitRes(4&, getD)
        execute_cb = 8
    Case 147 ' RES 2,E
        setE bitRes(4&, getE)
        execute_cb = 8
    Case 148 ' RES 2,H
        setH bitRes(4&, getH)
        execute_cb = 8
    Case 149 ' RES 2,L
        setL bitRes(4&, getL)
        execute_cb = 8
    Case 150 ' RES 2,(HL)
        pokeb regHL, bitRes(4&, peekb(regHL))
        execute_cb = 15
    Case 151 ' RES 2,A
        regA = bitRes(4&, regA)
        execute_cb = 8
    Case 152 ' RES 3,B
        regB = bitRes(8&, regB)
        execute_cb = 8
    Case 153 ' RES 3,C
        regC = bitRes(8&, regC)
        execute_cb = 8
    Case 154 ' RES 3,D
        setD bitRes(8&, getD)
        execute_cb = 8
    Case 155 ' RES 3,E
        setE bitRes(8&, getE)
        execute_cb = 8
    Case 156 ' RES 3,H
        setH bitRes(8&, getH)
        execute_cb = 8
    Case 157 ' RES 3,L
        setL bitRes(8&, getL)
        execute_cb = 8
    Case 158 ' RES 3,(HL)
        pokeb regHL, bitRes(8&, peekb(regHL))
        execute_cb = 15
    Case 159 ' RES 3,A
        regA = bitRes(8&, regA)
        execute_cb = 8
    Case 160 ' RES 4,B
        regB = bitRes(&H10&, regB)
        execute_cb = 8
    Case 161 ' RES 4,C
        regC = bitRes(&H10&, regC)
        execute_cb = 8
    Case 162 ' RES 4,D
        setD bitRes(&H10&, getD)
        execute_cb = 8
    Case 163 ' RES 4,E
        setE bitRes(&H10&, getE)
        execute_cb = 8
    Case 164 ' RES 4,H
        setH bitRes(&H10&, getH)
        execute_cb = 8
    Case 165 ' RES 4,L
        setL bitRes(&H10&, getL)
        execute_cb = 8
    Case 166 ' RES 4,(HL)
        pokeb regHL, bitRes(&H10&, peekb(regHL))
        execute_cb = 15
    Case 167 ' RES 4,A
        regA = bitRes(&H10&, regA)
        execute_cb = 8
    Case 168 ' RES 5,B
        regB = bitRes(&H20&, regB)
        execute_cb = 8
    Case 169 ' RES 5,C
        regC = bitRes(&H20&, regC)
        execute_cb = 8
    Case 170 ' RES 5,D
        setD bitRes(&H20&, getD)
        execute_cb = 8
    Case 171 ' RES 5,E
        setE bitRes(&H20&, getE)
        execute_cb = 8
    Case 172 ' RES 5,H
        setH bitRes(&H20&, getH)
        execute_cb = 8
    Case 173 ' RES 5,L
        setL bitRes(&H20&, getL)
        execute_cb = 8
    Case 174 ' RES 5,(HL)
        pokeb regHL, bitRes(&H20&, peekb(regHL))
        execute_cb = 15
    Case 175 ' RES 5,A
        regA = bitRes(&H20&, regA)
        execute_cb = 8
    Case 176 ' RES 6,B
        regB = bitRes(&H40&, regB)
        execute_cb = 8
    Case 177 ' RES 6,C
        regC = bitRes(&H40&, regC)
        execute_cb = 8
    Case 178 ' RES 6,D
        setD bitRes(&H40&, getD)
        execute_cb = 8
    Case 179 ' RES 6,E
        setE bitRes(&H40&, getE)
        execute_cb = 8
    Case 180 ' RES 6,H
        setH bitRes(&H40&, getH)
        execute_cb = 8
    Case 181 ' RES 6,L
        setL bitRes(&H40&, getL)
        execute_cb = 8
    Case 182 ' RES 6,(HL)
        pokeb regHL, bitRes(&H40&, peekb(regHL))
        execute_cb = 15
    Case 183 ' RES 6,A
        regA = bitRes(&H40&, regA)
        execute_cb = 8
        
    Case 184 ' RES 7,B
        regB = bitRes(&H80&, regB)
        execute_cb = 8
    Case 185 ' RES 7,C
        regC = bitRes(&H80&, regC)
        execute_cb = 8
    Case 186 ' RES 7,D
        setD bitRes(&H80&, getD)
        execute_cb = 8
    Case 187 ' RES 7,E
        setE bitRes(&H80&, getE)
        execute_cb = 8
    Case 188 ' RES 7,H
        setH bitRes(&H80&, getH)
        execute_cb = 8
    Case 189 ' RES 7,L
        setL bitRes(&H80&, getL)
        execute_cb = 8
    Case 190 ' RES 7,(HL)
        pokeb regHL, bitRes(&H80&, peekb(regHL))
        execute_cb = 15
    Case 191 ' RES 7,A
        regA = bitRes(&H80&, regA)
        execute_cb = 8
    Case 192 ' SET 0,B
        regB = bitSet(1&, regB)
        execute_cb = 8
    Case 193 ' SET 0,C
        regC = bitSet(1&, regC)
        execute_cb = 8
    Case 194 ' SET 0,D
        setD bitSet(1&, getD)
        execute_cb = 8
    Case 195 ' SET 0,E
        setE bitSet(1&, getE)
        execute_cb = 8
    Case 196 ' SET 0,H
        setH bitSet(1&, getH)
        execute_cb = 8
    Case 197 ' SET 0,L
        setL bitSet(1&, getL)
        execute_cb = 8
    Case 198 ' SET 0,(HL)
        pokeb regHL, bitSet(1&, peekb(regHL))
        execute_cb = 15
    Case 199 ' SET 0,A
        regA = bitSet(1&, regA)
        execute_cb = 8
    Case 200 ' SET 1,B
        regB = bitSet(2&, regB)
        execute_cb = 8
    Case 201 ' SET 1,C
        regC = bitSet(2&, regC)
        execute_cb = 8
    Case 202 ' SET 1,D
        setD bitSet(2&, getD)
        execute_cb = 8
    Case 203 ' SET 1,E
        setE bitSet(2&, getE)
        execute_cb = 8
    Case 204 ' SET 1,H
        setH bitSet(2&, getH)
        execute_cb = 8
    Case 205 ' SET 1,L
        setL bitSet(2&, getL)
        execute_cb = 8
    Case 206 ' SET 1,(HL)
        pokeb regHL, bitSet(2&, peekb(regHL))
        execute_cb = 15
    Case 207 ' SET 1,A
        regA = bitSet(2&, regA)
        execute_cb = 8
    Case 208 ' SET 2,B
        regB = bitSet(4&, regB)
        execute_cb = 8
    Case 209 ' SET 2,C
        regC = bitSet(4&, regC)
        execute_cb = 8
    Case 210 ' SET 2,D
        setD bitSet(4&, getD)
        execute_cb = 8
    Case 211 ' SET 2,E
        setE bitSet(4&, getE)
        execute_cb = 8
    Case 212 ' SET 2,H
        setH bitSet(4&, getH)
        execute_cb = 8
    Case 213 ' SET 2,L
        setL bitSet(4&, getL)
        execute_cb = 8
    Case 214 ' SET 2,(HL)
        pokeb regHL, bitSet(&H4&, peekb(regHL))
        execute_cb = 15
    Case 215 ' SET 2,A
        regA = bitSet(4&, regA)
        execute_cb = 8
    Case 216 ' SET 3,B
        regB = bitSet(8&, regB)
        execute_cb = 8
    Case 217 ' SET 3,C
        regC = bitSet(8&, regC)
        execute_cb = 8
    Case 218 ' SET 3,D
        setD bitSet(8&, getD)
        execute_cb = 8
    Case 219 ' SET 3,E
        setE bitSet(8&, getE)
        execute_cb = 8
    Case 220 ' SET 3,H
        setH bitSet(8&, getH)
        execute_cb = 8
    Case 221 ' SET 3,L
        setL bitSet(8&, getL)
        execute_cb = 8
    Case 222 ' SET 3,(HL)
        pokeb regHL, bitSet(&H8&, peekb(regHL))
        execute_cb = 15
    Case 223 ' SET 3,A
        regA = bitSet(8&, regA)
        execute_cb = 8
    Case 224 ' SET 4,B
        regB = bitSet(&H10&, regB)
        execute_cb = 8
    Case 225 ' SET 4,C
        regC = bitSet(&H10&, regC)
        execute_cb = 8
    Case 226 ' SET 4,D
        setD bitSet(&H10&, getD)
        execute_cb = 8
    Case 227 ' SET 4,E
        setE bitSet(&H10&, getE)
        execute_cb = 8
    Case 228 ' SET 4,H
        setH bitSet(&H10&, getH)
        execute_cb = 8
    Case 229 ' SET 4,L
        setL bitSet(&H10&, getL)
        execute_cb = 8
    Case 230 ' SET 4,(HL)
        pokeb regHL, bitSet(&H10&, peekb(regHL))
        execute_cb = 15
    Case 231 ' SET 4,A
        regA = bitSet(&H10&, regA)
        execute_cb = 8
    Case 232 ' SET 5,B
        regB = bitSet(&H20&, regB)
        execute_cb = 8
    Case 233 ' SET 5,C
        regC = bitSet(&H20&, regC)
        execute_cb = 8
    Case 234 ' SET 5,D
        setD bitSet(&H20&, getD)
        execute_cb = 8
    Case 235 ' SET 5,E
        setE bitSet(&H20&, getE)
        execute_cb = 8
    Case 236 ' SET 5,H
        setH bitSet(&H20&, getH)
        execute_cb = 8
    Case 237 ' SET 5,L
        setL bitSet(&H20&, getL)
        execute_cb = 8
    Case 238 ' SET 5,(HL)
        pokeb regHL, bitSet(&H20&, peekb(regHL))
        execute_cb = 15
    Case 239 ' SET 5,A
        regA = bitSet(&H20&, regA)
        execute_cb = 8
    Case 240 ' SET 6,B
        regB = bitSet(&H40&, regB)
        execute_cb = 8
    Case 241 ' SET 6,C
        regC = bitSet(&H40&, regC)
        execute_cb = 8
    Case 242 ' SET 6,D
        setD bitSet(&H40&, getD)
        execute_cb = 8
    Case 243 ' SET 6,E
        setE bitSet(&H40&, getE)
        execute_cb = 8
    Case 244 ' SET 6,H
        setH bitSet(&H40&, getH)
        execute_cb = 8
    Case 245 ' SET 6,L
        setL bitSet(&H40&, getL)
        execute_cb = 8
    Case 246 ' SET 6,(HL)
        pokeb regHL, bitSet(&H40&, peekb(regHL))
        execute_cb = 15
    Case 247 ' SET 6,A
        regA = bitSet(&H40&, regA)
        execute_cb = 8
    Case 248 ' SET 7,B
        regB = bitSet(&H80&, regB)
        execute_cb = 8
    Case 249 ' SET 7,C
        regC = bitSet(&H80&, regC)
        execute_cb = 8
    Case 250 ' SET 7,D
        setD bitSet(&H80&, getD)
        execute_cb = 8
    Case 251 ' SET 7,E
        setE bitSet(&H80&, getE)
        execute_cb = 8
    Case 252 ' SET 7,H
        setH bitSet(&H80&, getH)
        execute_cb = 8
    Case 253 ' SET 7,L
        setL bitSet(&H80&, getL)
        execute_cb = 8
    Case 254 ' SET 7,(HL)
        pokeb regHL, bitSet(&H80&, peekb(regHL))
        execute_cb = 15
    Case 255 ' SET 7,A
        regA = bitSet(&H80&, regA)
        execute_cb = 8
    Case Else
        MsgBox "Unknown CB instruction " & xxx & " at " & regPC
    End Select
End Function
Private Function execute_ed(ByVal local_tstates As Long) As Long
    Dim xxx As Long, count As Long, dest As Long, from As Long
    Dim TempLocal_tstates As Long, c As Boolean, b As Long
        
    ' // REFRESH 1
    intRTemp = intRTemp + 1
    
    xxx = nxtpcb
    Select Case xxx
    Case 0 To 63, 127 To 159, 164 To 167, 172 To 175, 180 To 183
        ' NOP
        execute_ed = 8
    ' // IN r,(c)
    Case 64 ' IN B,(c)
        regB = in_bc()
        execute_ed = 12
    Case 72 ' IN C,(c)
        regC = in_bc()
        execute_ed = 12
    Case 80 ' IN D,(c)
        setD in_bc()
        execute_ed = 12
    Case 88 ' IN E,(c)
        setE in_bc()
        execute_ed = 12
    Case 96 ' IN H,(c)
        setH in_bc()
        execute_ed = 12
    Case 104 ' IN L,(c)
        setL in_bc()
        execute_ed = 12
    Case 112 ' IN (c)
        in_bc
        execute_ed = 12
    Case 120 ' IN A,(c)
        regA = in_bc
        execute_ed = 12
        
    ' // OUT (c),r
    Case 65 ' OUT (c),B
        outb getBC, regB, local_tstates
        execute_ed = 12
    Case 73 ' OUT (c),C
        outb getBC, regC, local_tstates
        execute_ed = 12
    Case 81 ' OUT (c),D
        outb getBC, getD, local_tstates
        execute_ed = 12
    Case 89 ' OUT (c),E
        outb getBC, getE, local_tstates
        execute_ed = 12
    Case 97 ' OUT (c),H
        outb getBC, getH, local_tstates
        execute_ed = 12
    Case 105 ' OUT (c),L
        outb getBC, getL, local_tstates
        execute_ed = 12
    Case 113 ' OUT (c),0
        outb getBC, 0, local_tstates
        execute_ed = 12
    Case 121 ' OUT (c),A
        outb getBC, regA, local_tstates
        execute_ed = 12
        
    ' // SBC/ADC HL,ss
    Case 66 '  SBC HL,BC
        regHL = sbc16(regHL, getBC)
        execute_ed = 15
    Case 74 ' ADC HL,BC
        regHL = adc16(regHL, getBC)
        execute_ed = 15
    Case 82 ' SBC HL,DE
        regHL = sbc16(regHL, regDE)
    Case 90 ' ADC HL,DE
        regHL = adc16(regHL, regDE)
        execute_ed = 15
    Case 98 ' SBC HL,HL
        regHL = sbc16(regHL, regHL)
        execute_ed = 15
    Case 106 ' ADC HL,HL
        regHL = adc16(regHL, regHL)
        execute_ed = 15
    Case 114 ' SBC HL,SP
        regHL = sbc16(regHL, regSP)
        execute_ed = 15
    Case 122 ' ADC HL,SP
        regHL = adc16(regHL, regSP)
        execute_ed = 15
        
    ' // LD (nn),ss  /  LD ss,(nn)
    Case 67 ' LD (nn),BC
        pokew nxtpcw(), getBC
        execute_ed = 20
    Case 75 ' LD BC,(nn)
        setBC peekw(nxtpcw())
        execute_ed = 20
    Case 83 ' LD (nn),DE
        pokew nxtpcw(), regDE
        execute_ed = 20
    Case 91 ' LD DE,(nn)
        regDE = peekw(nxtpcw())
        execute_ed = 20
    Case 99 ' LD (nn),HL
        pokew nxtpcw(), regHL
        execute_ed = 20
    Case 107 ' LD HL,(nn)
        regHL = peekw(nxtpcw())
        execute_ed = 20
    Case 115 ' LD (nn),SP
        pokew nxtpcw(), regSP
        execute_ed = 20
    Case 123 ' LD SP,(nn)
        regSP = peekw(nxtpcw())
        execute_ed = 20
    
    ' // NEG
    Case 68, 76, 84, 92, 100, 108, 116, 124 ' NEG
        neg_a
        execute_ed = 8
        
    ' // RETn
    Case 69, 85, 101, 117
        intIFF1 = intIFF2
        poppc
        execute_ed = 14
    Case 77, 93, 109, 125 ' RETI
        ' // TOCHECK: according to the official Z80 docs, IFF2 does not get
        ' //          copied to IFF1 for RETI - but in a real Z80 it is
        intIFF1 = intIFF2
        poppc
        execute_ed = 14
            
    ' // IM x
    Case 70, 78, 102, 110 ' IM 0
        intIM = 0
        execute_ed = 8
    Case 86, 118 ' IM 1
        intIM = 1
        execute_ed = 8
    Case 94, 126 ' IM 2
        intIM = 2
        execute_ed = 8
    ' // LD s,a / RxD
    Case 71 ' LD I,A
        intI = regA
        execute_ed = 9
    Case 79 ' LD R,A
        intR = regA
        intRTemp = intR
        execute_ed = 9
    Case 87 ' LD A,I
        ld_a_i
        execute_ed = 9
    Case 95 ' LD A,R
        ld_a_r
        execute_ed = 9
    Case 103 ' RRD
        rrd_a
        execute_ed = 18
    Case 111  ' RLD
        rld_a
        execute_ed = 18
    
    ' // xxI
    Case 160 ' LDI
        pokeb regDE, peekb(regHL)
        regDE = inc16(regDE)
        regHL = inc16(regHL)
        setBC dec16(getBC)

        fPV = (getBC <> 0)
        fH = False
        fN = False

        execute_ed = 16
    Case 161 ' CPI
        c = fC

        cp_a peekb(regHL)
        regHL = inc16(regHL)
        setBC dec16(getBC)

        fPV = (getBC <> 0)
        fC = c

        execute_ed = 16
    Case 162 ' INI
        pokeb regHL, inb(getBC)
        b = qdec8(regB)
        regB = b
        regHL = inc16(regHL)

        fZ = (b = 0)
        fN = True

        execute_ed = 16
    Case 163 ' OUTI
        b = qdec8(regB)
        regB = b
        outb getBC, peekb(regHL), local_tstates
        regHL = inc16(regHL)

        fZ = (b = 0)
        fN = True

        execute_ed = 16
    
    ' /* xxD */
    Case 168 ' LDD
        pokeb regDE, peekb(regHL)
        regDE = dec16(regDE)
        regHL = dec16(regHL)
        setBC dec16(getBC())

        fPV = (getBC() <> 0)
        fH = False
        fN = False

        execute_ed = 16
    Case 169 ' CPD
        c = fC

        cp_a peekb(regHL)
        regHL = dec16(regHL)
        setBC dec16(getBC)

        fPV = (getBC <> 0)
        fC = c

        execute_ed = 16
    Case 170 ' IND
        pokeb regHL, inb(getBC)
        b = qdec8(regB)
        regB = b
        regHL = dec16(regHL)

        fZ = (b = 0)
        fN = True

        execute_ed = 16
    Case 171 ' OUTD
        count = qdec8(regB)
        regB = count
        outb getBC, peekb(regHL), local_tstates
        regHL = dec16(regHL)

        fZ = (count = 0)
        fN = True

        execute_ed = 16

    ' // xxIR
    Case 176 ' LDIR
        TempLocal_tstates = 0
        count = getBC
        dest = regDE
        from = regHL
        
        ' // REFRESH -2
        intRTemp = intRTemp - 2
        Do
            pokeb dest, peekb(from)
            from = (from + 1) And 65535
            dest = (dest + 1) And 65535
            count = count - 1
            
            TempLocal_tstates = TempLocal_tstates + 21
            ' // REFRESH (2)
            intRTemp = intRTemp + 2
            If (TempLocal_tstates >= 0) Then
                ' // interruptTriggered
                Exit Do
            End If
        Loop While count <> 0
        
        regPC = regPC - 2
        fH = False
        fN = False
        fPV = True
        
        If count = 0 Then
            regPC = regPC + 2
            TempLocal_tstates = TempLocal_tstates - 5
            fPV = False
        End If
        regDE = dest
        regHL = from
        setBC count
            
        execute_ed = TempLocal_tstates
    Case 177 ' CPIR
        c = fC
        
        cp_a peekb(regHL)
        regHL = inc16(regHL)
        setBC dec16(getBC)
        
        fC = c
        c = getBC <> 0
        fPV = c
        If (fPV) And (fZ = False) Then
            regPC = regPC - 2
            execute_ed = 21
        Else
            execute_ed = 16
        End If
    Case 178 ' INIR
        pokeb regHL, inb(getBC)
        b = qdec8(regB)
        regB = b
        regHL = inc16(regHL)

        fZ = True
        fN = True
        If (b <> 0) Then
            regPC = regPC - 2
            execute_ed = 21
        Else
            execute_ed = 16
        End If
    Case 179 ' OTIR
        b = qdec8(regB)
        regB = b
        outb getBC, peekb(regHL), local_tstates
        regHL = inc16(regHL)

        fZ = True
        fN = True
        If (b <> 0) Then
            regPC = regPC - 2
            execute_ed = 21
        Else
            execute_ed = 16
        End If

    ' // xxDR
    Case 184 ' LDDR
        TempLocal_tstates = 0
        count = getBC
        dest = regDE
        from = regHL
        
        ' // REFRESH -2
        intRTemp = intRTemp - 2
        Do
            pokeb dest, peekb(from)
            from = (from - 1) And 65535
            dest = (dest - 1) And 65535
            count = count - 1
            
            TempLocal_tstates = TempLocal_tstates + 21
            
            ' // REFRESH (2)
            intRTemp = intRTemp + 2
            
            If (TempLocal_tstates >= 0) Then
                ' // interruptTriggered
                Exit Do
            End If
        Loop While count <> 0
        regPC = regPC - 2
        fH = False
        fN = False
        fPV = True
        If count = 0 Then
            regPC = regPC + 2
            TempLocal_tstates = TempLocal_tstates - 5
            fPV = False
        End If
        
        regDE = dest
        regHL = from
        setBC count
            
        execute_ed = TempLocal_tstates
    Case 185 ' CPDR
        c = fC

        cp_a peekb(regHL)
        regHL = dec16(regHL)
        setBC dec16(getBC)

        fPV = getBC <> 0
        fC = c
        If (fPV) And (fZ = False) Then
            regPC = regPC - 2
            execute_ed = 21
        Else
            execute_ed = 16
        End If
    Case 186 ' INDR
        pokeb regHL, inb(getBC)
        b = qdec8(regB)
        regB = b
        regHL = dec16(regHL)

        fZ = True
        fN = True
        If (b <> 0) Then
            regPC = regPC - 2
            execute_ed = 21
        Else
            execute_ed = 16
        End If
    Case 187 ' OTDR
        b = qdec8(regB)
        regB = b
        outb getBC, peekb(regHL), local_tstates
        regHL = dec16(regHL)

        fZ = True
        fN = True
        If (b <> 0) Then
            regPC = regPC - 2
            execute_ed = 21
        Else
            execute_ed = 16
        End If
    Case 237
    Case Else
        MsgBox "Unknown ED instruction " & xxx & " at " & regPC
        execute_ed = 8
    End Select
End Function
Private Sub execute_id_cb(op As Long, ByVal z As Long)
    Select Case op
    Case 0 ' RLC B
        op = rlc(peekb(z))
        regB = op
        pokeb z, op
    Case 1 ' RLC C
        op = rlc(peekb(z))
        regC = op
        pokeb z, op
    Case 2 ' RLC D
        op = rlc(peekb(z))
        setD op
        pokeb z, op
    Case 3 ' RLC E
        op = rlc(peekb(z))
        setE op
        pokeb z, op
    Case 4 ' RLC H
        op = rlc(peekb(z))
        setH op
        pokeb z, op
    Case 5 ' RLC L
        op = rlc(peekb(z))
        setL op
        pokeb z, op
    Case 6 ' RLC (HL)
        pokeb z, rlc(peekb(z))
    Case 7 ' RLC A
        op = rlc(peekb(z))
        regA = op
        pokeb z, op
    Case 8 ' RRC B
        op = rrc(peekb(z))
        regB = op
        pokeb z, op
    Case 9 ' RRC C
        op = rrc(peekb(z))
        regC = op
        pokeb z, op
    Case 10 ' RRC D
        op = rrc(peekb(z))
        setD op
        pokeb z, op
    Case 11 ' RRC E
        op = rrc(peekb(z))
        setE op
        pokeb z, op
    Case 12 ' RRC H
        op = rrc(peekb(z))
        setH op
        pokeb z, op
    Case 13 ' RRC L
        op = rrc(peekb(z))
        setL op
        pokeb z, op
    Case 14 ' RRC (HL)
        pokeb z, rrc(peekb(z))
    Case 15 ' RRC A
        op = rrc(peekb(z))
        regA = op
        pokeb z, op
    Case 16 ' RL B
        op = rl(peekb(z))
        regB = op
        pokeb z, op
    Case 17 ' RL C
        op = rl(peekb(z))
        regC = op
        pokeb z, op
    Case 18 ' RL D
        op = rl(peekb(z))
        setD op
        pokeb z, op
    Case 19 ' RL E
        op = rl(peekb(z))
        setE op
        pokeb z, op
    Case 20 ' RL H
        op = rl(peekb(z))
        setH op
        pokeb z, op
    Case 21 ' RL L
        op = rl(peekb(z))
        setL op
        pokeb z, op
    Case 22 ' RL (HL)
        pokeb z, rl(peekb(z))
    Case 23 ' RL A
        op = rl(peekb(z))
        regA = op
        pokeb z, op
    Case 24 ' RR B
        op = rr(peekb(z))
        regB = op
        pokeb z, op
    Case 25 ' RR C
        op = rr(peekb(z))
        regC = op
        pokeb z, op
    Case 26 ' RR D
        op = rr(peekb(z))
        setD op
        pokeb z, op
    Case 27 ' RR E
        op = rr(peekb(z))
        setE op
        pokeb z, op
    Case 28 ' RR H
        op = rr(peekb(z))
        setH op
        pokeb z, op
    Case 29 ' RR L
        op = rr(peekb(z))
        setL op
        pokeb z, op
    Case 30 ' RR (HL)
        pokeb z, rr(peekb(z))
    Case 31 ' RR A
        op = rr(peekb(z))
        regA = op
        pokeb z, op
    Case 32 ' SLA B
        op = sla(peekb(z))
        regB = op
        pokeb z, op
    Case 33 ' SLA C
        op = sla(peekb(z))
        regC = op
        pokeb z, op
    Case 34 ' SLA D
        op = sla(peekb(z))
        setD op
        pokeb z, op
    Case 35 ' SLA E
        op = sla(peekb(z))
        setE op
        pokeb z, op
    Case 36 ' SLA H
        op = sla(peekb(z))
        setH op
        pokeb z, op
    Case 37 ' SLA L
        op = sla(peekb(z))
        setL op
        pokeb z, op
    Case 38 ' SLA (HL)
        pokeb z, sla(peekb(z))
    Case 39 ' SLA A
        op = sla(peekb(z))
        regA = op
        pokeb z, op
    Case 40 ' SRA B
        op = sra(peekb(z))
        regB = op
        pokeb z, op
    Case 41 ' SRA C
        op = sra(peekb(z))
        regC = op
        pokeb z, op
    Case 42 ' SRA D
        op = sra(peekb(z))
        setD op
        pokeb z, op
    Case 43 ' SRA E
        op = sra(peekb(z))
        setE op
        pokeb z, op
    Case 44 ' SRA H
        op = sra(peekb(z))
        setH op
        pokeb z, op
    Case 45 ' SRA L
        op = sra(peekb(z))
        setL op
        pokeb z, op
    Case 46 ' SRA (HL)
        pokeb z, sra(peekb(z))
    Case 47 ' SRA A
        op = sra(peekb(z))
        regA = op
        pokeb z, op
    Case 48 ' SLS B
        op = sls(peekb(z))
        regB = op
        pokeb z, op
    Case 49 ' SLS C
        op = sls(peekb(z))
        regC = op
        pokeb z, op
    Case 50 ' SLS D
        op = sls(peekb(z))
        setD op
        pokeb z, op
    Case 51 ' SLS E
        op = sls(peekb(z))
        setE op
        pokeb z, op
    Case 52 ' SLS H
        op = sls(peekb(z))
        setH op
        pokeb z, op
    Case 53 ' SLS L
        op = sls(peekb(z))
        setL op
        pokeb z, op
    Case 54 ' SLS (HL)
        pokeb z, sls(peekb(z))
    Case 55 ' SLS A
        op = sls(peekb(z))
        regA = op
        pokeb z, op
    Case 56 ' SRL B
        op = srl(peekb(z))
        regB = op
        pokeb z, op
    Case 57 ' SRL C
        op = srl(peekb(z))
        regC = op
        pokeb z, op
    Case 58 ' SRL D
        op = srl(peekb(z))
        setD op
        pokeb z, op
    Case 59 ' SRL E
        op = srl(peekb(z))
        setE op
        pokeb z, op
    Case 60 ' SRL H
        op = srl(peekb(z))
        setH op
        pokeb z, op
    Case 61 ' SRL L
        op = srl(peekb(z))
        setL op
        pokeb z, op
    Case 62 ' SRL (ID)
        pokeb z, srl(peekb(z))
    Case 63 ' SRL A
        op = srl(peekb(z))
        regA = op
        pokeb z, op
   Case 64 To 71 ' BIT 0,B
        bit &H1&, peekb(z)
    Case 72 To 79 ' BIT 1,B
        bit &H2&, peekb(z)
    Case 80 To 87 ' BIT 2,B
        bit &H4&, peekb(z)
    Case 88 To 95 ' BIT 3,B
        bit &H8&, peekb(z)
    Case 96 To 103 ' BIT 4,B
        bit &H10&, peekb(z)
    Case 104 To 111 ' BIT 5,B
        bit &H20&, peekb(z)
    Case 112 To 119 ' BIT 6,B
        bit &H40&, peekb(z)
    Case 120 To 127 ' BIT 7,B
        bit &H80&, peekb(z)
    Case 128 ' RES 0,(ID+y)->B
        regB = bitRes(1, peekb(z))
        pokeb z, regB
    Case 129 ' RES 0,(ID+y)->C
        regC = bitRes(1, peekb(z))
        pokeb z, regC
    Case 130 ' RES 0,(ID+y)->D
        setD bitRes(1, peekb(z))
        pokeb z, getD
    Case 131 ' RES 0,(ID+y)->E
        setE bitRes(1, peekb(z))
        pokeb z, getE
    Case 132 ' RES 0,(ID+y)->H
        setH bitRes(1, peekb(z))
        pokeb z, getH
    Case 133 ' RES 0,(ID+y)->L
        setL bitRes(1, peekb(z))
        pokeb z, getL
    Case 134 ' RES 0,(HL)
        pokeb z, bitRes(&H1&, peekb(z))
    Case 135 ' RES 0,(ID+y)->A
        regA = bitRes(1, peekb(z))
        pokeb z, regA
    Case 136 ' RES 1,(ID+y)->B
        regB = bitRes(2, peekb(z))
        pokeb z, regB
    Case 137 ' RES 1,(ID+y)->C
        regC = bitRes(2, peekb(z))
        pokeb z, regC
    Case 138 ' RES 1,(ID+y)->D
        setD bitRes(2, peekb(z))
        pokeb z, getD
    Case 139 ' RES 1,(ID+y)->E
        setE bitRes(2, peekb(z))
        pokeb z, getE
    Case 140 ' RES 1,(ID+y)->H
        setH bitRes(2, peekb(z))
        pokeb z, getH
    Case 141 ' RES 1,(ID+y)->L
        setL bitRes(2, peekb(z))
        pokeb z, getL
    Case 142 ' RES 1,(HL)
        pokeb z, bitRes(&H2&, peekb(z))
    Case 143 ' RES 1,(ID+y)->A
        regA = bitRes(2, peekb(z))
        pokeb z, regA
    Case 144 ' RES 2,(ID+y)->B
        regB = bitRes(4, peekb(z))
        pokeb z, regB
    Case 145 ' RES 2,(ID+y)->C
        regC = bitRes(4, peekb(z))
        pokeb z, regC
    Case 146 ' RES 2,(ID+y)->D
        setD bitRes(4, peekb(z))
        pokeb z, getD
    Case 147 ' RES 2,(ID+y)->E
        setE bitRes(4, peekb(z))
        pokeb z, getE
    Case 148 ' RES 2,(ID+y)->H
        setH bitRes(4, peekb(z))
        pokeb z, getH
    Case 149 ' RES 2,(ID+y)->L
        setL bitRes(4, peekb(z))
        pokeb z, getL
    Case 150 ' RES 2,(HL)
        pokeb z, bitRes(&H4&, peekb(z))
    Case 151 ' RES 2,(ID+y)->A
        regA = bitRes(4, peekb(z))
        pokeb z, regA
    Case 152 ' RES 3,(ID+y)->B
        regB = bitRes(8, peekb(z))
        pokeb z, regB
    Case 153 ' RES 3,(ID+y)->C
        regC = bitRes(8, peekb(z))
        pokeb z, regC
    Case 154 ' RES 3,(ID+y)->D
        setD bitRes(8, peekb(z))
        pokeb z, getD
    Case 155 ' RES 3,(ID+y)->E
        setE bitRes(8, peekb(z))
        pokeb z, getE
    Case 156 ' RES 3,(ID+y)->H
        setH bitRes(8, peekb(z))
        pokeb z, getH
    Case 157 ' RES 3,(ID+y)->L
        setL bitRes(8, peekb(z))
        pokeb z, getL
    Case 158 ' RES 3,(HL)
        pokeb z, bitRes(&H8&, peekb(z))
    Case 159 ' RES 3,(ID+y)->A
        regA = bitRes(8, peekb(z))
        pokeb z, regA
    Case 160 ' RES 4,(ID+y)->B
        regB = bitRes(&H10&, peekb(z))
        pokeb z, regB
    Case 161 ' RES 4,(ID+y)->C
        regC = bitRes(&H10&, peekb(z))
        pokeb z, regC
    Case 162 ' RES 4,(ID+y)->D
        setD bitRes(&H10&, peekb(z))
        pokeb z, getD
    Case 163 ' RES 4,(ID+y)->E
        setE bitRes(&H10&, peekb(z))
        pokeb z, getE
    Case 164 ' RES 4,(ID+y)->H
        setH bitRes(&H10&, peekb(z))
        pokeb z, getH
    Case 165 ' RES 4,(ID+y)->L
        setL bitRes(&H10&, peekb(z))
        pokeb z, getL
    Case 166 ' RES 4,(HL)
        pokeb z, bitRes(&H10&, peekb(z))
    Case 167 ' RES 4,(ID+y)->A
        regA = bitRes(&H10&, peekb(z))
        pokeb z, regA
    Case 168 ' RES 5,(ID+y)->B
        regB = bitRes(&H20&, peekb(z))
        pokeb z, regB
    Case 169 ' RES 5,(ID+y)->C
        regC = bitRes(&H20&, peekb(z))
        pokeb z, regC
    Case 170 ' RES 5,(ID+y)->D
        setD bitRes(&H20&, peekb(z))
        pokeb z, getD
    Case 171 ' RES 5,(ID+y)->E
        setE bitRes(&H20&, peekb(z))
        pokeb z, getE
    Case 172 ' RES 5,(ID+y)->H
        setH bitRes(&H20&, peekb(z))
        pokeb z, getH
    Case 173 ' RES 5,(ID+y)->L
        setL bitRes(&H20&, peekb(z))
        pokeb z, getL
    Case 174 ' RES 5,(HL)
        pokeb z, bitRes(&H20&, peekb(z))
    Case 175 ' RES 5,(ID+y)->A
        regA = bitRes(&H20&, peekb(z))
        pokeb z, regA
    Case 176 ' RES 6,(ID+y)->B
        regB = bitRes(&H40&, peekb(z))
        pokeb z, regB
    Case 177 ' RES 6,(ID+y)->C
        regC = bitRes(&H40&, peekb(z))
        pokeb z, regC
    Case 178 ' RES 6,(ID+y)->D
        setD bitRes(&H40&, peekb(z))
        pokeb z, getD
    Case 179 ' RES 6,(ID+y)->E
        setE bitRes(&H40&, peekb(z))
        pokeb z, getE
    Case 180 ' RES 6,(ID+y)->H
        setH bitRes(&H40&, peekb(z))
        pokeb z, getH
    Case 181 ' RES 6,(ID+y)->L
        setL bitRes(&H40&, peekb(z))
        pokeb z, getL
    Case 182 ' RES 6,(HL)
        pokeb z, bitRes(&H40&, peekb(z))
    Case 183 ' RES 6,(ID+y)->A
        regA = bitRes(&H40&, peekb(z))
        pokeb z, regA
    Case 184 ' RES 6,(ID+y)->B
        regB = bitRes(&H80&, peekb(z))
        pokeb z, regB
    Case 185 ' RES 6,(ID+y)->C
        regC = bitRes(&H80&, peekb(z))
        pokeb z, regC
    Case 186 ' RES 6,(ID+y)->D
        setD bitRes(&H80&, peekb(z))
        pokeb z, getD
    Case 187 ' RES 6,(ID+y)->E
        setE bitRes(&H80&, peekb(z))
        pokeb z, getE
    Case 188 ' RES 6,(ID+y)->H
        setH bitRes(&H80&, peekb(z))
        pokeb z, getH
    Case 189 ' RES 6,(ID+y)->L
        setL bitRes(&H80&, peekb(z))
        pokeb z, getL
    Case 190 ' RES 7,(HL)
        pokeb z, bitRes(&H80&, peekb(z))
    Case 191 ' RES 7,(ID+y)->A
        regA = bitRes(&H80&, peekb(z))
        pokeb z, regA
    Case 192 ' SET 0,(ID+y)->B
        regB = bitSet(1, peekb(z))
        pokeb z, regB
    Case 193 ' SET 0,(ID+y)->C
        regC = bitSet(1, peekb(z))
        pokeb z, regC
    Case 194 ' SET 0,(ID+y)->D
        setD bitSet(1, peekb(z))
        pokeb z, getD
    Case 195 ' SET 0,(ID+y)->E
        setE bitSet(1, peekb(z))
        pokeb z, getE
    Case 196 ' SET 0,(ID+y)->H
        setH bitSet(1, peekb(z))
        pokeb z, getH
    Case 197 ' SET 0,(ID+y)->L
        setL bitSet(1, peekb(z))
        pokeb z, getL
    Case 198 ' SET 0,(HL)
        pokeb z, bitSet(&H1&, peekb(z))
    Case 199 ' SET 0,(ID+y)->A
        regA = bitSet(1, peekb(z))
        pokeb z, regA
    Case 200 ' SET 1,(ID+y)->B
        regB = bitSet(2, peekb(z))
        pokeb z, regB
    Case 201 ' SET 1,(ID+y)->C
        regC = bitSet(2, peekb(z))
        pokeb z, regC
    Case 202 ' SET 1,(ID+y)->D
        setD bitSet(2, peekb(z))
        pokeb z, getD
    Case 203 ' SET 1,(ID+y)->E
        setE bitSet(2, peekb(z))
        pokeb z, getE
    Case 204 ' SET 1,(ID+y)->H
        setH bitSet(2, peekb(z))
        pokeb z, getH
    Case 205 ' SET 1,(ID+y)->L
        setL bitSet(2, peekb(z))
        pokeb z, getL
    Case 206 ' SET 1,(HL)
        pokeb z, bitSet(&H2&, peekb(z))
    Case 207 ' SET 1,(ID+y)->A
        regA = bitSet(2, peekb(z))
        pokeb z, regA
    Case 208 ' SET 2,(ID+y)->B
        regB = bitSet(4, peekb(z))
        pokeb z, regB
    Case 209 ' SET 2,(ID+y)->C
        regC = bitSet(4, peekb(z))
        pokeb z, regC
    Case 210 ' SET 2,(ID+y)->D
        setD bitSet(4, peekb(z))
        pokeb z, getD
    Case 211 ' SET 2,(ID+y)->E
        setE bitSet(4, peekb(z))
        pokeb z, getE
    Case 212 ' SET 2,(ID+y)->H
        setH bitSet(4, peekb(z))
        pokeb z, getH
    Case 213 ' SET 2,(ID+y)->L
        setL bitSet(4, peekb(z))
        pokeb z, getL
    Case 214 ' SET 2,(HL)
        pokeb z, bitSet(&H4&, peekb(z))
    Case 215 ' SET 2,(ID+y)->A
        regA = bitSet(4, peekb(z))
        pokeb z, regA
    Case 216 ' SET 3,(ID+y)->B
        regB = bitSet(8, peekb(z))
        pokeb z, regB
    Case 217 ' SET 3,(ID+y)->C
        regC = bitSet(8, peekb(z))
        pokeb z, regC
    Case 218 ' SET 3,(ID+y)->D
        setD bitSet(8, peekb(z))
        pokeb z, getD
    Case 219 ' SET 3,(ID+y)->E
        setE bitSet(8, peekb(z))
        pokeb z, getE
    Case 220 ' SET 3,(ID+y)->H
        setH bitSet(8, peekb(z))
        pokeb z, getH
    Case 221 ' SET 3,(ID+y)->L
        setL bitSet(8, peekb(z))
        pokeb z, getL
    Case 222 ' SET 3,(HL)
        pokeb z, bitSet(&H8&, peekb(z))
    Case 223 ' SET 3,(ID+y)->A
        regA = bitSet(8, peekb(z))
        pokeb z, regA
    Case 224 ' SET 4,(ID+y)->B
        regB = bitSet(&H10&, peekb(z))
        pokeb z, regB
    Case 225 ' SET 4,(ID+y)->C
        regC = bitSet(&H10&, peekb(z))
        pokeb z, regC
    Case 226 ' SET 4,(ID+y)->D
        setD bitSet(&H10&, peekb(z))
        pokeb z, getD
    Case 227 ' SET 4,(ID+y)->E
        setE bitSet(&H10&, peekb(z))
        pokeb z, getE
    Case 228 ' SET 4,(ID+y)->H
        setH bitSet(&H10&, peekb(z))
        pokeb z, getH
    Case 229 ' SET 4,(ID+y)->L
        setL bitSet(&H10&, peekb(z))
        pokeb z, getL
    Case 230 ' SET 4,(HL)
        pokeb z, bitSet(&H10&, peekb(z))
    Case 231 ' SET 4,(ID+y)->A
        regA = bitSet(&H10&, peekb(z))
        pokeb z, regA
    Case 232 ' SET 5,(ID+y)->B
        regB = bitSet(&H20&, peekb(z))
        pokeb z, regB
    Case 233 ' SET 5,(ID+y)->C
        regC = bitSet(&H20&, peekb(z))
        pokeb z, regC
    Case 234 ' SET 5,(ID+y)->D
        setD bitSet(&H20&, peekb(z))
        pokeb z, getD
    Case 235 ' SET 5,(ID+y)->E
        setE bitSet(&H20&, peekb(z))
        pokeb z, getE
    Case 236 ' SET 5,(ID+y)->H
        setH bitSet(&H20&, peekb(z))
        pokeb z, getH
    Case 237 ' SET 5,(ID+y)->L
        setL bitSet(&H20&, peekb(z))
        pokeb z, getL
    Case 238 ' SET 5,(HL)
        pokeb z, bitSet(&H20&, peekb(z))
    Case 239 ' SET 5,(ID+y)->A
        regA = bitSet(&H20&, peekb(z))
        pokeb z, regA
    Case 240 ' SET 6,(ID+y)->B
        regB = bitSet(&H40&, peekb(z))
        pokeb z, regB
    Case 241 ' SET 6,(ID+y)->C
        regC = bitSet(&H40&, peekb(z))
        pokeb z, regC
    Case 242 ' SET 6,(ID+y)->D
        setD bitSet(&H40&, peekb(z))
        pokeb z, getD
    Case 243 ' SET 6,(ID+y)->E
        setE bitSet(&H40&, peekb(z))
        pokeb z, getE
    Case 244 ' SET 6,(ID+y)->H
        setH bitSet(&H40&, peekb(z))
        pokeb z, getH
    Case 245 ' SET 6,(ID+y)->L
        setL bitSet(&H40&, peekb(z))
        pokeb z, getL
    Case 246 ' SET 6,(HL)
        pokeb z, bitSet(&H40&, peekb(z))
    Case 247 ' SET 6,(ID+y)->A
        regA = bitSet(&H40&, peekb(z))
        pokeb z, regA
    Case 248 ' SET 7,(ID+y)->B
        regB = bitSet(&H80&, peekb(z))
        pokeb z, regB
    Case 249 ' SET 7,(ID+y)->C
        regC = bitSet(&H80&, peekb(z))
        pokeb z, regC
    Case 250 ' SET 7,(ID+y)->D
        setD bitSet(&H80&, peekb(z))
        pokeb z, getD
    Case 251 ' SET 7,(ID+y)->E
        setE bitSet(&H80&, peekb(z))
        pokeb z, getE
    Case 252 ' SET 7,(ID+y)->H
        setH bitSet(&H80&, peekb(z))
        pokeb z, getH
    Case 253 ' SET 7,(ID+y)->L
        setL bitSet(&H80&, peekb(z))
        pokeb z, getL
    Case 254 ' SET 7,(HL)
        pokeb z, bitSet(&H80&, peekb(z))
    Case 255 ' SET 7,A
        regA = bitSet(&H80&, peekb(z))
        pokeb z, regA
    End Select
End Sub



Private Sub exx()
    Dim t As Long
    
    t = regHL
    regHL = regHL_
    regHL_ = t
    
    t = regDE
    regDE = regDE_
    regDE_ = t
    
    t = getBC
    setBC regBC_
    regBC_ = t
End Sub

Private Function getAF()
    getAF = (regA * 256&) Or getF
End Function

Private Function getBC()
    getBC = (regB * 256&) Or regC
End Function

Private Function getD() As Long
    getD = regDE \ 256&
End Function
Private Function getE() As Long
    getE = regDE And &HFF&
End Function

Private Function getF() As Long
    If fS Then getF = getF Or F_S
    If fZ Then getF = getF Or F_Z
    If f5 Then getF = getF Or F_5
    If fH Then getF = getF Or F_H
    If f3 Then getF = getF Or F_3
    If fPV Then getF = getF Or F_PV
    If fN Then getF = getF Or F_N
    If fC Then getF = getF Or F_C
End Function

Private Function getH() As Long
    getH = regHL \ 256&
End Function

Private Function getIDH() As Long
    getIDH = (regID \ 256) And &HFF&
End Function
Private Function getIDL() As Long
    getIDL = regID And &HFF&
End Function


Private Function getL() As Long
    getL = regHL And &HFF&
End Function

Private Function id_d() As Long
    Dim d As Long
    
    d = nxtpcb()
    If d And 128 Then d = -(256 - d)
    id_d = (regID + d) And &HFFFF&
End Function
Private Sub ld_a_i()
    fS = (intI And F_S) <> 0
    f3 = (intI And F_3) <> 0
    f5 = (intI And F_5) <> 0
    fZ = (intI = 0)
    fPV = intIFF2
    fH = False
    fN = False

    regA = intI
End Sub

Private Sub ld_a_r()
    regA = (intR And &H80&) Or (intRTemp And 127)
    fS = (regA And F_S) <> 0
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fZ = (regA = 0)
    fPV = intIFF2
    fH = False
    fN = False
End Sub

Private Sub neg_a()
    Dim t As Long
    
    t = regA
    regA = 0
    sub_a t
End Sub

Private Sub rld_a()
    Dim ans As Long, t As Long, q As Long
    
    ans = regA
    t = peekb(regHL)
    q = t

    t = (t * 16) Or (ans And &HF&)
    ans = (ans And &HF0&) Or (q \ 16)
    pokeb regHL, (t And &HFF&)

    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = intIFF2
    fH = False
    fN = False
    
    regA = ans
End Sub

Private Sub setIDH(byteval As Long)
    regID = ((byteval * 256&) And &HFF00&) Or (regID And &HFF&)
End Sub

Private Sub setIDL(byteval As Long)
    regID = (regID And &HFF00&) Or (byteval And &HFF&)
End Sub

Private Function in_bc() As Long
    Dim ans As Long
    
    ans = inb(getBC)
    
    fZ = (ans = 0)
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fPV = Parity(ans)
    fN = False
    fH = False
    
    in_bc = ans
End Function

Private Function inc8(ByVal ans As Long) As Long
    fPV = (ans = &H7F&)
    fH = (((ans And &HF&) + 1) And F_H) <> 0
    
    ans = (ans + 1) And &HFF&

    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fN = False
    
    inc8 = ans
End Function
Private Function dec8(ByVal ans As Long) As Long
    fPV = (ans = &H80&)
    fH = (((ans And &HF&) - 1) And F_H) <> 0
    
    ans = (ans - 1) And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    
    fN = True
    
    dec8 = ans
End Function

Private Function interrupt() As Long
    Dim lSleep As Long
    
    interruptCounter = interruptCounter + 1
    
    ' // Attribute flash (state alters every 1/2 second)
    If (interruptCounter Mod 25) = 0 Then
        refreshFlashChars
    End If
      
    If (interruptCounter Mod refreshRate) = 0 Then
        screenPaint
    End If
    
    ' // PERFORM Z80 hardware functions
    
    ' // If it's a maskable interrupt
    If intIFF1 = False Then
        interrupt = 0
    Else
        Select Case intIM
        Case 0, 1
            pushpc
            intIFF1 = False
            intIFF2 = False
            regPC = 56
            interrupt = 13
        Case 2
            pushpc
            intIFF1 = False
            intIFF2 = False
            regPC = (intI * 256&) Or &HFF&
            regPC = peekw(regPC)
            interrupt = 19
        End Select
    End If
    
    DoEvents
    ' // Keep the emulation running at the correct speed by
    ' // adding a delay to ensure that interrupts are
    ' // generated at the correct frequency
    If timeGetTime() < glInterruptTimer Then
        lSleep = glInterruptTimer - timeGetTime()
        If lSleep >= 0 Then Sleep lSleep
    End If
    
    glInterruptTimer = timeGetTime() + glInterruptDelay
End Function
Private Function interruptTriggered(tstates As Long) As Boolean
    interruptTriggered = (tstates >= 0)
End Function

Private Sub or_a(b As Long)
    regA = (regA Or b)
    
    fS = (regA And F_S) <> 0
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fH = False
    fPV = Parity(regA)
    fZ = (regA = 0)
    fN = False
    fC = False
End Sub

Private Function peekw(addr As Long) As Long
    peekw = peekb(addr) Or (peekb((addr + 1)) * 256&)
End Function

Private Sub pokeb(addr As Long, newByte As Long)
    If addr >= 23296 Then
        ' // Non-video RAM
        mem(addr) = newByte
        Exit Sub
    End If
    
    If addr < 16384 Then
        ' // ROM
        Exit Sub
    End If
    
    ' // Video RAM
    If mem(addr) <> newByte Then
        mem(addr) = newByte
        plot addr, newByte
    End If
End Sub

Private Sub pokew(addr As Long, word As Long)
    pokeb addr, (word And &HFF&)
    
    pokeb (addr + 1 And &HFFFF&), (word And &HFF00&) \ 256&
End Sub

Public Sub poppc()
    regPC = popw
End Sub
Private Function popw()
    popw = peekb(regSP) Or (peekb(regSP + 1) * 256&)
    regSP = (regSP + 2 And &HFFFF&)
End Function

Private Sub pushpc()
    pushw regPC
End Sub

Private Sub pushw(word As Long)
    regSP = (regSP - 2) And &HFFFF&
    pokew regSP, word
End Sub


Private Sub REFRESH(t As Long)
    intRTemp = intRTemp + t
End Sub

Private Function rl(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H80&) <> 0
    
    If fC Then
        ans = (ans * 2) Or &H1&
    Else
        ans = ans * 2
    End If
    ans = ans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
        
    rl = ans
End Function
Private Sub rl_a()
    Dim ans As Long, c As Boolean
    
    ans = regA
    c = (ans And &H80&) <> 0
    
    If fC Then
        ans = (ans * 2) Or &H1&
    Else
        ans = (ans * 2)
    End If
    ans = ans And &HFF&
    
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fN = False
    fH = False
    fC = c
    
    regA = ans
End Sub

Private Function rlc(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H80&) <> 0
    
    If c Then
        ans = (ans * 2) Or &H1&
    Else
        ans = (ans * 2)
    End If
    
    ans = ans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
    
    rlc = ans
End Function

Private Sub rlc_a()
    Dim c As Boolean
    
    c = (regA And &H80&) <> 0
    
    If c Then
        regA = (regA * 2) Or 1
    Else
        regA = (regA * 2)
    End If
    regA = regA And &HFF&
    
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fN = False
    fH = False
    fC = c
End Sub

Private Function rr(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H1&) <> 0
    
    If fC Then
        ans = (ans \ 2) Or &H80&
    Else
        ans = (ans \ 2)
    End If

    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
        
    rr = ans
End Function

Private Sub rr_a()
    Dim ans As Long, c As Boolean
    
    ans = regA
    c = (ans And &H1&) <> 0
    
    If fC Then
        ans = (ans \ 2) Or &H80&
    Else
        ans = (ans \ 2)
    End If
        
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fN = False
    fH = False
    fC = c
    
    regA = ans
End Sub

Private Function rrc(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H1&) <> 0
    
    If c Then
        ans = (ans \ 2) Or &H80&
    Else
        ans = (ans \ 2)
    End If
      
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
    
    rrc = ans
End Function

Private Sub rrd_a()
    Dim ans As Long, t As Long, q As Long
    
    ans = regA
    t = peekb(regHL)
    q = t

    t = (t \ 16&) Or (ans * 16&)
    ans = (ans And &HF0&) Or (q And &HF&)
    pokeb regHL, t

    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = intIFF2
    fH = False
    fN = False
    
    regA = ans
End Sub

Private Sub rrc_a()
    Dim c As Boolean
    
    c = (regA And &H1&) <> 0
    
    If c Then
        regA = (regA \ 2) Or &H80&
    Else
        regA = regA \ 2
    End If
        
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fN = False
    fH = False
    fC = c
End Sub

Private Sub sbc_a(ByVal b As Long)
    Dim a As Long, wans As Long, ans As Long, c As Long
    
    a = regA
    
    If fC Then c = 1

    wans = a - b - c
    ans = wans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fC = (wans And &H100&) <> 0
    fPV = ((a Xor b) And (a Xor ans) And &H80&) <> 0
    fH = (((a And &HF&) - (b And &HF&) - c) And F_H) <> 0
    fN = True
    
    regA = ans
End Sub

Private Function sbc16(a As Long, b As Long) As Long
    Dim c As Long, lans As Long, ans As Long
    
    If fC Then c = 1
    
    lans = a - b - c
    ans = lans And &HFFFF&
    
    fS = (ans And (F_S * 256&)) <> 0
    f3 = (ans And (F_3 * 256&)) <> 0
    f5 = (ans And (F_5 * 256&)) <> 0
    fZ = (ans = 0)
    fC = (lans And &H10000) <> 0
    fPV = ((a Xor b) And (a Xor ans) And &H8000&) <> 0
    fH = (((a And &HFFF&) - (b And &HFFF&) - c) And &H1000&) <> 0
    fN = True
    
    sbc16 = ans
End Function

Private Sub scf()
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fN = False
    fH = False
    fC = True
End Sub

Public Sub setAF(v As Long)
    regA = (v And &HFF00&) \ 256&
    setF (v And &HFF&)
End Sub

Public Sub setBC(nn As Long)
    regB = (nn And &HFF00&) \ 256&
    regC = nn And &HFF&
End Sub

Public Sub execute()
    Dim local_tstates As Long, d As Long, lTemp As Long
    Dim xxx As Long
    
    local_tstates = -glTstatesPerInterrupt
    While True
        If (local_tstates >= 0) Then
            ' // Trigger an interrupt
            local_tstates = local_tstates - glTstatesPerInterrupt - interrupt()
        End If
                    
        ' // REFRESH 1
        intRTemp = intRTemp + 1
        
        xxx = nxtpcb()
        Select Case xxx
        Case 0 ' NOP
            local_tstates = local_tstates + 4
        Case 8 ' EX AF,AF'
            ex_af_af
            local_tstates = local_tstates + 4
        Case 16 ' DJNZ dis
            lTemp = qdec8(regB)
            
            regB = lTemp
            If lTemp <> 0 Then
                d = nxtpcb()
                If d And 128 Then d = -(256 - d)
                regPC = (regPC + d) And &HFFFF&
                local_tstates = local_tstates + 13
            Else
                regPC = inc16(regPC)
                local_tstates = local_tstates + 8
            End If
        Case 24 ' JR dis
            d = nxtpcb()
            If d And 128 Then d = -(256 - d)
            regPC = (regPC + d) And &HFFFF&
            local_tstates = local_tstates + 12
        Case 32 ' JR NZ dis
            If fZ = False Then
                d = nxtpcb()
                If d And 128 Then d = -(256 - d)
                regPC = ((regPC + d) And &HFFFF&)
                local_tstates = local_tstates + 12
            Else
                regPC = inc16(regPC)
                local_tstates = local_tstates + 7
            End If
        Case 40 ' JR Z dis
            If fZ = True Then
                d = nxtpcb()
                If d And 128 Then d = -(256 - d)
                regPC = ((regPC + d) And &HFFFF&)
                local_tstates = local_tstates + 12
            Else
                regPC = inc16(regPC)
                local_tstates = local_tstates + 7
            End If
        Case 48  ' JR NC dis
            If fC = False Then
                d = nxtpcb()
                If d And 128 Then d = -(256 - d)
                regPC = ((regPC + d) And &HFFFF&)
                local_tstates = local_tstates + 12
            Else
                regPC = inc16(regPC)
                local_tstates = local_tstates + 7
            End If
        Case 56 ' JR C dis
            If fC = True Then
                d = nxtpcb()
                If d And 128 Then d = -(256 - d)
                regPC = ((regPC + d) And &HFFFF&)
                local_tstates = local_tstates + 12
            Else
                regPC = inc16(regPC)
                local_tstates = local_tstates + 7
            End If
        ' // LD rr,nn
        Case 1 ' LD BC,nn
            setBC nxtpcw()
            local_tstates = local_tstates + 10
        Case 9  ' ADD HL,BC
            regHL = add16(regHL, getBC())
            local_tstates = local_tstates + 11
        Case 17 ' LD DE,nn
            regDE = nxtpcw()
            local_tstates = local_tstates + 10
        Case 25 ' ADD HL,DE
            regHL = add16(regHL, regDE)
            local_tstates = local_tstates + 11
        Case 33 ' LD HL,nn
            regHL = nxtpcw()
            local_tstates = local_tstates + 10
        Case 41 ' ADD HL,HL
            regHL = add16(regHL, regHL)
            local_tstates = local_tstates + 11
        Case 49 ' LD SP,nn
            regSP = nxtpcw()
            local_tstates = local_tstates + 10
        Case 57 ' ADD HL,SP
            regHL = add16(regHL, regSP)
            local_tstates = local_tstates + 11
        ' // LD (**),A/A,(**)
        Case 2 ' LD (BC),A
            pokeb getBC, regA
            local_tstates = local_tstates + 7
        Case 10 ' LD A,(BC)
            regA = peekb(getBC)
            local_tstates = local_tstates + 7
        Case 18 ' LD (DE),A
            pokeb regDE, regA
            local_tstates = local_tstates + 7
        Case 26 ' LD A,(DE)
            regA = peekb(regDE)
            local_tstates = local_tstates + 7
        Case 34 ' LD (nn),HL
            pokew nxtpcw(), regHL
            local_tstates = local_tstates + 16
        Case 42 ' LD HL,(nn)
            regHL = peekw(nxtpcw())
            local_tstates = local_tstates + 16
        Case 50 ' LD (nn),A
            pokeb nxtpcw, regA
            local_tstates = local_tstates + 13
        Case 58 ' LD A,(nn)
            regA = peekb(nxtpcw())
            local_tstates = local_tstates + 13
        ' // INC/DEC
        Case 3 ' INC BC
            setBC inc16(getBC)
            local_tstates = local_tstates + 6
        Case 11 ' DEC BC
            setBC dec16(getBC)
            local_tstates = local_tstates + 6
        Case 19 ' INC DE
            regDE = inc16(regDE)
            local_tstates = local_tstates + 6
        Case 27 ' DEC DE
            regDE = dec16(regDE)
            local_tstates = local_tstates + 6
        Case 35 ' INC HL
            regHL = inc16(regHL)
            local_tstates = local_tstates + 6
        Case 43 ' DEC HL
            regHL = dec16(regHL)
            local_tstates = local_tstates + 6
        Case 51 ' INC SP
            regSP = inc16(regSP)
            local_tstates = local_tstates + 6
        Case 59 ' DEC SP
            regSP = dec16(regSP)
            local_tstates = local_tstates + 6
        ' // INC
        Case 4 ' INC B
            regB = inc8(regB)
            local_tstates = local_tstates + 4
        Case 12 ' INC C
            regC = inc8(regC)
            local_tstates = local_tstates + 4
        Case 20 ' INC D
            setD inc8(getD)
            local_tstates = local_tstates + 4
        Case 28 ' INC E
            setE inc8(getE)
            local_tstates = local_tstates + 4
        Case 36 ' INC H
            setH inc8(getH)
            local_tstates = local_tstates + 4
        Case 44 ' INC L
            setL inc8(getL)
            local_tstates = local_tstates + 4
        Case 52 ' INC (HL)
            pokeb regHL, inc8(peekb(regHL))
            local_tstates = local_tstates + 11
        Case 60 ' INC A
            regA = inc8(regA)
            local_tstates = local_tstates + 4
        
        ' // DEC
        Case 5 ' DEC B
            regB = dec8(regB)
            local_tstates = local_tstates + 4
        Case 13 ' DEC C
            regC = dec8(regC)
            local_tstates = local_tstates + 4
        Case 21 ' DEC D
            setD dec8(getD)
            local_tstates = local_tstates + 4
        Case 29 ' DEC E
            setE dec8(getE)
            local_tstates = local_tstates + 4
        Case 37 ' DEC H
            setH dec8(getH)
            local_tstates = local_tstates + 4
        Case 45 ' DEC L
            setL dec8(getL)
            local_tstates = local_tstates + 4
        Case 53 ' DEC (HL)
            pokeb regHL, dec8(peekb(regHL))
            local_tstates = local_tstates + 11
        Case 61 ' DEC A
            regA = dec8(regA)
            local_tstates = local_tstates + 4
        
        ' // LD *,N
        Case 6 ' LD B,n
            regB = nxtpcb()
            local_tstates = local_tstates + 7
        Case 14 ' LD C,n
            regC = nxtpcb()
            local_tstates = local_tstates + 7
        Case 22 ' LD D,n
            setD nxtpcb()
            local_tstates = local_tstates + 7
        Case 30 ' LD E,n
            setE nxtpcb()
            local_tstates = local_tstates + 7
        Case 38 ' LD H,n
            setH nxtpcb()
            local_tstates = local_tstates + 7
        Case 46 ' LD L,n
            setL nxtpcb()
            local_tstates = local_tstates + 7
        Case 54 ' LD (HL),n
            pokeb regHL, nxtpcb()
            local_tstates = local_tstates + 10
        Case 62 ' LD A,n
            regA = nxtpcb()
            local_tstates = local_tstates + 7
        
        ' // R**A
        Case 7 ' RLCA
            rlc_a
            local_tstates = local_tstates + 4
        Case 15 ' RRCA
            rrc_a
            local_tstates = local_tstates + 4
        Case 23 ' RLA
            rl_a
            local_tstates = local_tstates + 4
        Case 31 ' RRA
            rr_a
            local_tstates = local_tstates + 4
        Case 39 ' DAA
            daa_a
            local_tstates = local_tstates + 4
        Case 47 ' CPL
            cpl_a
            local_tstates = local_tstates + 4
        Case 55 ' SCF
            scf
            local_tstates = local_tstates + 4
        Case 63 ' CCF
            ccf
            local_tstates = local_tstates + 4
        
        ' // LD B,*
        Case 64 ' LD B,B
            local_tstates = local_tstates + 4
        Case 65 ' LD B,C
            regB = regC
            local_tstates = local_tstates + 4
        Case 66 ' LD B,D
            regB = getD
            local_tstates = local_tstates + 4
        Case 67 ' LD B,E
            regB = getE
            local_tstates = local_tstates + 4
        Case 68 ' LD B,H
            regB = getH
            local_tstates = local_tstates + 4
        Case 69 ' LD B,L
            regB = getL
            local_tstates = local_tstates + 4
        Case 70 ' LD B,(HL)
            regB = peekb(regHL)
            local_tstates = local_tstates + 7
        Case 71 ' LD B,A
            regB = regA
            local_tstates = local_tstates + 4
            
        ' // LD C,*
        Case 72 ' LD C,B
            regC = regB
            local_tstates = local_tstates + 4
        Case 73 ' LD C,C
            local_tstates = local_tstates + 4
        Case 74 ' LD C,D
            regC = getD
            local_tstates = local_tstates + 4
        Case 75 ' LD C,E
            regC = getE
            local_tstates = local_tstates + 4
        Case 76 ' LD C,H
            regC = getH
            local_tstates = local_tstates + 4
        Case 77 ' LD C,L
            regC = getL
            local_tstates = local_tstates + 4
        Case 78 ' LD C,(HL)
            regC = peekb(regHL)
            local_tstates = local_tstates + 7
        Case 79 ' LD C,A
            regC = regA
            local_tstates = local_tstates + 4
            
        ' // LD D,*
        Case 80 ' LD D,B
            setD regB
            local_tstates = local_tstates + 4
        Case 81 ' LD D,C
            setD regC
            local_tstates = local_tstates + 4
        Case 82 ' LD D,D
            local_tstates = local_tstates + 4
        Case 83 ' LD D,E
            setD getE
            local_tstates = local_tstates + 4
        Case 84 ' LD D,H
            setD getH
            local_tstates = local_tstates + 4
        Case 85 ' LD D,L
            setD getL
            local_tstates = local_tstates + 4
        Case 86 ' LD D,(HL)
            setD peekb(regHL)
            local_tstates = local_tstates + 7
        Case 87 ' LD D,A
            setD regA
            local_tstates = local_tstates + 4
        
        ' // LD E,*
        Case 88 ' LD E,B
            setE regB
            local_tstates = local_tstates + 4
        Case 89 ' LD E,C
            setE regC
            local_tstates = local_tstates + 4
        Case 90 ' LD E,D
            setE getD
            local_tstates = local_tstates + 4
        Case 91 ' LD E,E
            local_tstates = local_tstates + 4
        Case 92 ' LD E,H
            setE getH
            local_tstates = local_tstates + 4
        Case 93 ' LD E,L
            setE getL
            local_tstates = local_tstates + 4
        Case 94 ' LD E,(HL)
            setE peekb(regHL)
            local_tstates = local_tstates + 7
        Case 95 ' LD E,A
            setE regA
            local_tstates = local_tstates + 4
        
        ' // LD H,*
        Case 96 ' LD H,B
            setH regB
            local_tstates = local_tstates + 4
        Case 97 ' LD H,C
            setH regC
            local_tstates = local_tstates + 4
        Case 98 ' LD H,D
            setH getD
            local_tstates = local_tstates + 4
        Case 99 ' LD H,E
            setH getE
            local_tstates = local_tstates + 4
        Case 100 ' LD H,H
            local_tstates = local_tstates + 4
        Case 101 ' LD H,L
            setH getL
            local_tstates = local_tstates + 4
        Case 102 ' LD H,(HL)
            setH peekb(regHL)
            local_tstates = local_tstates + 7
        Case 103 ' LD H,A
            setH regA
            local_tstates = local_tstates + 4
            
        ' // LD L,*
        Case 104 ' LD L,B
            setL regB
            local_tstates = local_tstates + 4
        Case 105 ' LD L,C
            setL regC
            local_tstates = local_tstates + 4
        Case 106 ' LD L,D
            setL getD
            local_tstates = local_tstates + 4
        Case 107 ' LD L,E
            setL getE
            local_tstates = local_tstates + 4
        Case 108 ' LD L,H
            setL getH
            local_tstates = local_tstates + 4
        Case 109 ' LD L,L
            local_tstates = local_tstates + 4
        Case 110 ' LD L,(HL)
            setL peekb(regHL)
            local_tstates = local_tstates + 7
        Case 111 ' LD L,A
            setL regA
            local_tstates = local_tstates + 4
        
        ' // LD (HL),*
        Case 112 ' LD (HL),B
            pokeb regHL, regB
            local_tstates = local_tstates + 7
        Case 113 ' LD (HL),C
            pokeb regHL, regC
            local_tstates = local_tstates + 7
        Case 114 ' LD (HL),D
            pokeb regHL, getD
            local_tstates = local_tstates + 7
        Case 115 ' LD (HL),E
            pokeb regHL, getE
            local_tstates = local_tstates + 7
        Case 116 ' LD (HL),H
            pokeb regHL, getH
            local_tstates = local_tstates + 7
        Case 117 ' LD (HL),L
            pokeb regHL, getL
            local_tstates = local_tstates + 7
        Case 118 ' HALT
            lTemp = (((-local_tstates - 1) \ 4) + 1)
            local_tstates = local_tstates + (lTemp * 4)
            intRTemp = intRTemp + (lTemp - 1)
            
        Case 119 ' LD (HL),A
            pokeb regHL, regA
            local_tstates = local_tstates + 7
        
        ' // LD A,*
        Case 120 ' LD A,B
            regA = regB
            local_tstates = local_tstates + 4
        Case 121 ' LD A,C
            regA = regC
            local_tstates = local_tstates + 4
        Case 122 ' LD A,D
            regA = getD
            local_tstates = local_tstates + 4
        Case 123 ' LD A,E
            regA = getE
            local_tstates = local_tstates + 4
        Case 124 ' LD A,H
            regA = getH
            local_tstates = local_tstates + 4
        Case 125 ' LD A,L
            regA = getL
            local_tstates = local_tstates + 4
        Case 126 ' LD A,(HL)
            regA = peekb(regHL)
            local_tstates = local_tstates + 7
        Case 127 ' LD A,A
            local_tstates = local_tstates + 4
        
        ' // ADD A,*
        Case 128 ' ADD A,B
            add_a regB
            local_tstates = local_tstates + 4
        Case 129 ' ADD A,C
            add_a regC
            local_tstates = local_tstates + 4
        Case 130 ' ADD A,D
            add_a getD
            local_tstates = local_tstates + 4
        Case 131 ' ADD A,E
            add_a getE
            local_tstates = local_tstates + 4
        Case 132 ' ADD A,H
            add_a getH
            local_tstates = local_tstates + 4
        Case 133 ' ADD A,L
            add_a getL
            local_tstates = local_tstates + 4
        Case 134 ' ADD A,(HL)
            add_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 135 ' ADD A,A
            add_a regA
            local_tstates = local_tstates + 4
            
        ' // ADC A,*
        Case 136 ' ADC A,B
            adc_a regB
            local_tstates = local_tstates + 4
        Case 137 ' ADC A,C
            adc_a regC
            local_tstates = local_tstates + 4
        Case 138 ' ADC A,D
            adc_a getD
            local_tstates = local_tstates + 4
        Case 139 ' ADC A,E
            adc_a getE
            local_tstates = local_tstates + 4
        Case 140 ' ADC A,H
            adc_a getH
            local_tstates = local_tstates + 4
        Case 141 ' ADC A,L
            adc_a getL
            local_tstates = local_tstates + 4
        Case 142 ' ADC A,(HL)
            adc_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 143 ' ADC A,A
            adc_a regA
            local_tstates = local_tstates + 4
            
        ' // SUB *
        Case 144 ' SUB B
            sub_a regB
            local_tstates = local_tstates + 4
        Case 145 ' SUB C
            sub_a regC
            local_tstates = local_tstates + 4
        Case 146 ' SUB D
            sub_a getD
            local_tstates = local_tstates + 4
        Case 147 ' SUB E
            sub_a getE
            local_tstates = local_tstates + 4
        Case 148 ' SUB H
            sub_a getH
            local_tstates = local_tstates + 4
        Case 149 ' SUB L
            sub_a getL
            local_tstates = local_tstates + 4
        Case 150 ' SUB (HL)
            sub_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 151 ' SUB A
            sub_a regA
            local_tstates = local_tstates + 4
            
        ' // SBC A,*
        Case 152 ' SBC A,B
            sbc_a regB
            local_tstates = local_tstates + 4
        Case 153 ' SBC A,C
            sbc_a regC
            local_tstates = local_tstates + 4
        Case 154 ' SBC A,D
            sbc_a getD
            local_tstates = local_tstates + 4
        Case 155 ' SBC A,E
            sbc_a getE
            local_tstates = local_tstates + 4
        Case 156 ' SBC A,H
            sbc_a getH
            local_tstates = local_tstates + 4
        Case 157 ' SBC A,L
            sbc_a getL
            local_tstates = local_tstates + 4
        Case 158 ' SBC A,(HL)
            sbc_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 159 ' SBC A,A
            sbc_a regA
            local_tstates = local_tstates + 4
        
        ' // AND *
        Case 160 ' AND B
            and_a regB
            local_tstates = local_tstates + 4
        Case 161 ' AND C
            and_a regC
            local_tstates = local_tstates + 4
        Case 162 ' AND D
            and_a getD
            local_tstates = local_tstates + 4
        Case 163 ' AND E
            and_a getE
            local_tstates = local_tstates + 4
        Case 164 ' AND H
            and_a getH
            local_tstates = local_tstates + 4
        Case 165 ' AND L
            and_a getL
            local_tstates = local_tstates + 4
        Case 166 ' AND (HL)
            and_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 167 ' AND A
            and_a regA
            local_tstates = local_tstates + 4
        
        ' // XOR *
        Case 168 ' XOR B
            xor_a regB
            local_tstates = local_tstates + 4
        Case 169 ' XOR C
            xor_a regC
            local_tstates = local_tstates + 4
        Case 170 ' XOR D
            xor_a getD
            local_tstates = local_tstates + 4
        Case 171 ' XOR E
            xor_a getE
            local_tstates = local_tstates + 4
        Case 172 ' XOR H
            xor_a getH
            local_tstates = local_tstates + 4
        Case 173 ' XOR L
            xor_a getL
            local_tstates = local_tstates + 4
        Case 174 ' XOR (HL)
            xor_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 175 ' XOR A
            regA = 0
            fS = False
            f3 = False
            f5 = False
            fH = False
            fPV = True
            fZ = True
            fN = False
            fC = False
            local_tstates = local_tstates + 4
        ' // OR *
        Case 176 ' OR B
            or_a regB
            local_tstates = local_tstates + 4
        Case 177 ' OR C
            or_a regC
            local_tstates = local_tstates + 4
        Case 178 ' OR D
            or_a getD
            local_tstates = local_tstates + 4
        Case 179 ' OR E
            or_a getE
            local_tstates = local_tstates + 4
        Case 180 ' OR H
            or_a getH
            local_tstates = local_tstates + 4
        Case 181 ' OR L
            or_a getL
            local_tstates = local_tstates + 4
        Case 182 ' OR (HL)
            or_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 183 ' OR A
            or_a regA
            local_tstates = local_tstates + 4
        
        ' // CP
        Case 184 ' CP B
            cp_a regB
            local_tstates = local_tstates + 4
        Case 185 ' CP C
            cp_a regC
            local_tstates = local_tstates + 4
        Case 186 ' CP D
            cp_a getD
            local_tstates = local_tstates + 4
        Case 187 ' CP E
            cp_a getE
            local_tstates = local_tstates + 4
        Case 188 ' CP H
            cp_a getH
            local_tstates = local_tstates + 4
        Case 189 ' CP L
            cp_a getL
            local_tstates = local_tstates + 4
        Case 190 ' CP (HL)
            cp_a peekb(regHL)
            local_tstates = local_tstates + 7
        Case 191 ' CP A
            cp_a regA
            local_tstates = local_tstates + 4
        
        ' // RET cc
        Case 192 ' RET NZ
            If fZ = False Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 200 ' RET Z
            If fZ Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 208 ' RET NC
            If fC = False Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 216 ' RET C
            If fC Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 224 ' RET PO
            If fPV = False Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 232 ' RET PE
            If fPV Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 240 ' RET P
            If fS = False Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
        Case 248 ' RET M
            If fS Then
                poppc
                local_tstates = local_tstates + 11
            Else
                local_tstates = local_tstates + 5
            End If
            
        ' // POP,Various
        Case 193 ' POP BC
            setBC popw
            local_tstates = local_tstates + 10
        Case 201 ' RET
            poppc
            local_tstates = local_tstates + 10
        Case 209 ' POP DE
            regDE = popw
            local_tstates = local_tstates + 10
        Case 217 ' EXX
            exx
            local_tstates = local_tstates + 4
        Case 225 ' POP HL
            regHL = popw
            local_tstates = local_tstates + 10
        Case 233 ' JP HL
            regPC = regHL
            local_tstates = local_tstates + 4
        Case 241 ' POP AF
            setAF popw
            local_tstates = local_tstates + 10
        Case 249 ' LD SP,HL
            regSP = regHL
            local_tstates = local_tstates + 6
            
        ' // JP cc,nn
        Case 194 ' JP NZ,nn
            If fZ = False Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 202 ' JP Z,nn
            If fZ Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 210 '  JP NC,nn
            If fC = False Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 218 ' JP C,nn
            If fC Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 226 ' JP PO,nn
            If fPV = False Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 234 ' JP PE,nn
            If fPV Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 242 ' JP P,nn
            If fS = False Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
        Case 250 ' JP M,nn
            If fS Then
                regPC = nxtpcw
            Else
                regPC = regPC + 2
            End If
            local_tstates = local_tstates + 10
            
        ' // Various
        Case 195 ' JP nn
            regPC = peekw(regPC)
            local_tstates = local_tstates + 10
        Case 203 ' prefix CB
            local_tstates = local_tstates + execute_cb
        Case 211 ' OUT (n),A
            outb nxtpcb, regA, local_tstates
            local_tstates = local_tstates + 11
        Case 219 ' IN A,(n)
            regA = inb((regA * 256) Or nxtpcb)
            local_tstates = local_tstates + 11
        Case 227 ' EX (SP),HL
            lTemp = regHL
            regHL = peekw(regSP)
            pokew regSP, lTemp
            local_tstates = local_tstates + 19
        Case 235 ' EX DE,HL
            lTemp = regHL
            regHL = regDE
            regDE = lTemp
            local_tstates = local_tstates + 4
        Case 243 ' DI
            intIFF1 = False
            intIFF2 = False
            local_tstates = local_tstates + 4
        Case 251 ' EI
            intIFF1 = True
            intIFF2 = True
            local_tstates = local_tstates + 4
        
        ' // CALL NZ,nn
        Case 196 ' CALL NZ,nn
            If fZ = False Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 204 ' CALL Z,nn
            If fZ Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 212 ' CALL NC,nn
            If fC = False Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 220 ' CALL C,nn
            If fC Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 228 ' CALL PO,nn
            If fPV = False Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 236 ' CALL PE,nn
            If fPV Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 244 ' CALL P,nn
            If fS = False Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
        Case 252 ' CALL M,nn
            If fS Then
                pushw regPC + 2
                regPC = nxtpcw
                local_tstates = local_tstates + 17
            Else
                regPC = regPC + 2
                local_tstates = local_tstates + 10
            End If
         
        ' // PUSH,Various
        Case 197 ' PUSH BC
            pushw getBC
            local_tstates = local_tstates + 11
        Case 205 ' CALL nn
            pushw regPC + 2
            regPC = nxtpcw
            local_tstates = local_tstates + 17
        Case 213 ' PUSH DE
            pushw regDE
            local_tstates = local_tstates + 11
        Case 221 ' prefix IX
            regID = regIX
            local_tstates = local_tstates + execute_id()
            regIX = regID
        Case 229 ' PUSH HL
            pushw regHL
            local_tstates = local_tstates + 11
        Case 237 ' prefix ED
            local_tstates = local_tstates + execute_ed(local_tstates)
            
        Case 245 ' PUSH AF
            pushw getAF
            local_tstates = local_tstates + 11
        Case 253 ' prefix IY
            regID = regIY
            local_tstates = local_tstates + execute_id()
            regIY = regID
        
        ' // op A,n
        Case 198 ' ADD A,n
            add_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 206 ' ADC A,n
            adc_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 214 ' SUB n
            sub_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 222 ' SBC n
            sbc_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 230 ' AND n
            and_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 238 ' XOR n
            xor_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 246 ' OR n
            or_a nxtpcb()
            local_tstates = local_tstates + 7
        Case 254 ' CP n
            cp_a nxtpcb()
            local_tstates = local_tstates + 7
            
        ' // RST n
        Case 199 ' RST 0
            pushpc
            regPC = 0
            local_tstates = local_tstates + 11
        Case 207 ' RST 8
            pushpc
            regPC = 8
            local_tstates = local_tstates + 11
        Case 215 ' RST 16
            pushpc
            regPC = 16
            local_tstates = local_tstates + 11
        Case 223 ' RST 24
            pushpc
            regPC = 24
            local_tstates = local_tstates + 11
        Case 231 ' RST 32
            pushpc
            regPC = 32
            local_tstates = local_tstates + 11
        Case 239 ' RST 40
            pushpc
            regPC = 40
            local_tstates = local_tstates + 11
        Case 247 ' RST 48
            pushpc
            regPC = 48
            local_tstates = local_tstates + 11
        Case 255 ' RST 56
            pushpc
            regPC = 56
            local_tstates = local_tstates + 11
        Case Else
            MsgBox "Unknown instruction " & xxx & " at " & regPC
        End Select
    Wend
End Sub

Private Function qdec8(a As Long) As Long
    qdec8 = (a - 1) And &HFF&
End Function

Private Function execute_id() As Long
     Dim xxx As Long, lTemp As Long, op As Long
    
    ' // REFRESH 1
    intRTemp = intRTemp + 1
    
    xxx = nxtpcb
    Select Case xxx
    Case 0 To 8, 10 To 24, 26 To 32, 39, 40, 47 To 51, 55, 56, 58 To 67
        regPC = dec16(regPC)
        ' // REFRESH -1
        intRTemp = intRTemp - 1
        execute_id = 4
    Case 71 To 75, 79 To 83, 87 To 91, 95, 120 To 123, 127 To 131
        regPC = dec16(regPC)
        ' // REFRESH -1
        intRTemp = intRTemp - 1
        execute_id = 4
    Case 135 To 139, 143 To 147, 151 To 155, 159 To 163, 167 To 171
        regPC = dec16(regPC)
        ' // REFRESH -1
        intRTemp = intRTemp - 1
        execute_id = 4
    Case 175 To 179, 183 To 187, 191 To 202, 204 To 224, 226, 228
        regPC = dec16(regPC)
        ' // REFRESH -1
        intRTemp = intRTemp - 1
        execute_id = 4
    Case 230 To 232, 234 To 248
        regPC = dec16(regPC)
        ' // REFRESH -1
        intRTemp = intRTemp - 1
        execute_id = 4
    Case 9 ' ADD ID,BC
        regID = add16(regID, getBC)
        execute_id = 15
    Case 25 ' ADD ID,DE
        regID = add16(regID, regDE)
        execute_id = 15
    Case 41 ' ADD ID,ID
        lTemp = regID
        regID = add16(lTemp, lTemp)
        execute_id = 15
    Case 57 ' ADD ID,SP
        regID = add16(regID, regSP)
        execute_id = 15
    Case 33 ' LD ID,nn
        regID = nxtpcw
        execute_id = 14
    Case 34 ' LD (nn),ID
        pokew nxtpcw, regID
        execute_id = 20
    Case 42 ' LD ID,(nn)
        regID = peekw(nxtpcw)
        execute_id = 20
    Case 35 ' INC ID
        regID = inc16(regID)
        execute_id = 10
    Case 43 ' DEC ID
        regID = dec16(regID)
        execute_id = 10
    Case 36 ' INC IDH
        setIDH inc8(getIDH)
        execute_id = 9
    Case 44 ' INC IDL
        setIDL inc8(getIDL)
        execute_id = 9
    Case 52 ' INC (ID+d)
        lTemp = id_d
        pokeb lTemp, inc8(peekb(lTemp))
        execute_id = 23
    Case 37 ' DEC IDH
        setIDH dec8(getIDH)
        execute_id = 9
    Case 45 ' DEC IDL
        setIDL dec8(getIDL)
        execute_id = 9
    Case 53 ' DEC (ID+d)
        lTemp = id_d
        pokeb lTemp, dec8(peekb(lTemp))
        execute_id = 23
    Case 38 ' LD IDH,n
        setIDH nxtpcb()
        execute_id = 11
    Case 46 ' LD IDL,n
        setIDL nxtpcb()
        execute_id = 11
    Case 54 ' LD (ID+d),n
        lTemp = id_d
        pokeb lTemp, nxtpcb()
        execute_id = 19
    Case 68 ' LD B,IDH
        regB = getIDH
        execute_id = 9
    Case 69 ' LD B,IDL
        regB = getIDL
        execute_id = 9
    Case 70 ' LD B,(ID+d)
        regB = peekb(id_d)
        execute_id = 19
    Case 76 ' LD C,IDH
        regC = getIDH
        execute_id = 9
    Case 77 ' LD C,IDL
        regC = getIDL
        execute_id = 9
    Case 78 ' LD C,(ID+d)
        regC = peekb(id_d)
        execute_id = 19
    Case 84 ' LD D,IDH
        setD getIDH
        execute_id = 9
    Case 85 ' LD D,IDL
        setD getIDL
        execute_id = 9
    Case 86 ' LD D,(ID+d)
        setD peekb(id_d)
        execute_id = 19
    Case 92 ' LD E,IDH
        setE getIDH
        execute_id = 9
    Case 93 ' LD E,IDL
        setE getIDL
        execute_id = 9
    Case 94 ' LD E,(ID+d)
        setE peekb(id_d)
        execute_id = 19
    Case 96 ' LD IDH,B
        setIDH regB
        execute_id = 9
    Case 97 ' LD IDH,C
        setIDH regC
        execute_id = 9
    Case 98 ' LD IDH,D
        setIDH getD
        execute_id = 9
    Case 99 ' LD IDH,E
        setIDH getE
        execute_id = 9
    Case 100 ' LD IDH,IDH
        execute_id = 9
    Case 101 ' LD IDH,IDL
        setIDH getIDL
        execute_id = 9
    Case 102 ' LD H,(ID+d)
        setH peekb(id_d)
        execute_id = 19
    Case 103 ' LD IDH,A
        setIDH regA
        execute_id = 9
    Case 104 ' LD IDL,B
        setIDL regB
        execute_id = 9
    Case 105 ' LD IDL,C
        setIDL regC
        execute_id = 9
    Case 106 ' LD IDL,D
        setIDL getD
        execute_id = 9
    Case 107 ' LD IDL,E
        setIDL getE
        execute_id = 9
    Case 108 ' LD IDL,IDH
        setIDL getIDH
        execute_id = 9
    Case 109 ' LD IDL,IDL
        execute_id = 9
    Case 110 ' LD L,(ID+d)
        setL peekb(id_d)
        execute_id = 19
    Case 111 ' LD IDL,A
        setIDL regA
        execute_id = 9
    Case 112 ' LD (ID+d),B
        pokeb id_d, regB
        execute_id = 19
    Case 113 ' LD (ID+d),C
        pokeb id_d, regC
        execute_id = 19
    Case 114 ' LD (ID+d),D
        pokeb id_d, getD
        execute_id = 19
    Case 115 ' LD (ID+d),E
        pokeb id_d, getE
        execute_id = 19
    Case 116 ' LD (ID+d),H
        pokeb id_d, getH
        execute_id = 19
    Case 117 ' LD (ID+d),L
        pokeb id_d, getL
        execute_id = 19
    Case 119 ' LD (ID+d),A
        pokeb id_d, regA
        execute_id = 19
    Case 124 ' LD A,IDH
        regA = getIDH
        execute_id = 9
    Case 125 ' LD A,IDL
        regA = getIDL
        execute_id = 9
    Case 126 ' LD A,(ID+d)
        regA = peekb(id_d)
        execute_id = 19
    Case 132 ' ADD A,IDH
        add_a getIDH
        execute_id = 9
    Case 133 ' ADD A,IDL
        add_a getIDL
        execute_id = 9
    Case 134 ' ADD A,(ID+d)
        add_a peekb(id_d)
        execute_id = 19
        
    Case 140 ' ADC A,IDH
        adc_a getIDH
        execute_id = 9
    Case 141 ' ADC A,IDL
        adc_a getIDL
        execute_id = 9
    Case 142 ' ADC A,(ID+d)
        adc_a peekb(id_d)
        execute_id = 19
    Case 148 ' SUB IDH
        sub_a getIDH
        execute_id = 9
    Case 149 ' SUB IDL
        sub_a getIDL
        execute_id = 9
    Case 150 ' SUB (ID+d)
        sub_a peekb(id_d)
        execute_id = 19
    Case 156 ' SBC A,IDH
        sbc_a getIDH
        execute_id = 9
    Case 157 ' SBC A,IDL
        sbc_a getIDL
        execute_id = 9
    Case 158 ' SBC A,(ID+d)
        sbc_a peekb(id_d)
        execute_id = 19
    Case 164 ' AND IDH
        and_a getIDH
        execute_id = 9
    Case 165 ' AND IDL
        and_a getIDL
        execute_id = 9
    Case 166 ' AND (ID+d)
        and_a peekb(id_d)
        execute_id = 19
    Case 172 ' XOR IDH
        xor_a getIDH
        execute_id = 9
    Case 173 ' XOR IDL
        xor_a getIDL
        execute_id = 9
    Case 174 'XOR (ID+d)
        xor_a (peekb(id_d))
        execute_id = 19
    Case 180 ' OR IDH
        or_a getIDH
        execute_id = 9
    Case 181 ' OR IDL
        or_a getIDL
        execute_id = 9
    Case 182 ' OR (ID+d)
        or_a peekb(id_d)
        execute_id = 19
    Case 188 ' CP IDH
        cp_a getIDH
        execute_id = 9
    Case 189 ' CP IDL
        cp_a getIDL
        execute_id = 9
    Case 190 ' CP (ID+d)
        cp_a peekb(id_d)
        execute_id = 19
    Case 203 ' prefix CB
        lTemp = id_d
        op = nxtpcb()
        execute_id_cb op, lTemp
        If ((op And &HC0&) = &H40&) Then execute_id = 20 Else execute_id = 23
    Case 225 ' POP ID
        regID = popw()
        execute_id = 14
    Case 227 ' EX (SP),ID
        lTemp = regID
        regID = peekw(regSP)
        pokew regSP, lTemp
        execute_id = 23
    Case 229 ' PUSH ID
        pushw regID
        execute_id = 15
    Case 233 ' JP ID
        regPC = regID
        execute_id = 8
    Case 249 ' LD SP,ID
        regSP = regID
        execute_id = 10
    Case Else
        MsgBox "Unknown ID instruction " & xxx & " at " & regPC
    End Select
End Function

Private Function inc16(a As Long) As Long
    inc16 = (a + 1) And &HFFFF&
End Function

Private Function nxtpcw() As Long
    nxtpcw = peekb(regPC) + (peekb(regPC + 1) * 256&)
    regPC = regPC + 2
End Function

Private Function nxtpcb() As Long
    nxtpcb = peekb(regPC)
    regPC = regPC + 1
End Function


Private Function peekb(addr As Long) As Long
    peekb = mem(addr)
End Function


Private Sub setD(l As Long)
    regDE = (l * 256&) Or (regDE And &HFF&)
End Sub
Private Sub setE(l As Long)
    regDE = (regDE And &HFF00&) Or l
End Sub

Public Sub setF(b As Long)
    fS = (b And F_S) <> 0
    fZ = (b And F_Z) <> 0
    f5 = (b And F_5) <> 0
    fH = (b And F_H) <> 0
    f3 = (b And F_3) <> 0
    fPV = (b And F_PV) <> 0
    fN = (b And F_N) <> 0
    fC = (b And F_C) <> 0
End Sub

Private Sub setH(l As Long)
    regHL = (l * 256&) Or (regHL And &HFF&)
End Sub


Private Sub setL(l As Long)
    regHL = (regHL And &HFF00&) Or l
End Sub



Private Function sla(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H80&) <> 0
    ans = (ans * 2) And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
    
    sla = ans
End Function

Private Function sls(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H80&) <> 0
    ans = ((ans * 2) Or &H1&) And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
    
    sls = ans
End Function

Private Function sra(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H1&) <> 0
    ans = (ans \ 2) Or (ans And &H80&)
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
    
    sra = ans
End Function

Private Function srl(ByVal ans As Long) As Long
    Dim c As Boolean
    
    c = (ans And &H1&) <> 0
    ans = ans \ 2
        
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fPV = Parity(ans)
    fH = False
    fN = False
    fC = c
    
    srl = ans
End Function

Private Sub sub_a(b As Long)
    Dim a As Long, wans As Long, ans As Long
    
    a = regA
    wans = a - b
    ans = wans And &HFF&
    
    fS = (ans And F_S) <> 0
    f3 = (ans And F_3) <> 0
    f5 = (ans And F_5) <> 0
    fZ = (ans = 0)
    fC = (wans And &H100&) <> 0
    fPV = ((a Xor b) And (a Xor ans) And &H80&) <> 0
    fH = (((a And &HF&) - (b And &HF&)) And F_H) <> 0
    fN = True
    
    regA = ans
End Sub


Private Sub xor_a(b As Long)
    regA = (regA Xor b) And &HFF&
    
    fS = (regA And F_S) <> 0
    f3 = (regA And F_3) <> 0
    f5 = (regA And F_5) <> 0
    fH = False
    fPV = Parity(regA)
    fZ = (regA = 0)
    fN = False
    fC = False
End Sub

Public Sub Z80Reset()
    regPC = 0
    regSP = 0
    regA = 0
    setF 0
    setBC 0
    regDE = 0
    regHL = 0
    
    exx
    ex_af_af
    
    regA = 0
    setF 0
    setBC 0
    regDE = 0
    regHL = 0
    
    regIX = 0
    regIY = 0
    intR = 0
    intRTemp = 0
    
    intI = 0
    intIFF1 = False
    intIFF2 = False
    intIM = 0
    
    frmMainWnd.Caption = App.ProductName
End Sub


